-----DEBUG CONTROL--------------------------------------------------------------

debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value).."\n")
  end
end


-- NoIndex: true

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--

--------------------------------
 --REATRAK LOCAL GUI LIBRARY start
--------------------------------
local info = debug.getinfo(1,'S');
script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]
--Msg("script_path "..script_path)
 local lib_path = script_path --reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
--if not lib_path or lib_path == "" then
    --reaper.MB("Couldn't load the ReaTrak Lokasenna_GUI library. Please check Scripts/ReaTrak/ReaTrak_Classes/", "Whoops!", 0)
    --return
--end
inipath = reaper.get_ini_file()

loadfile(script_path .. "ReaTrak_Core.lua")()

GUI.req(script_path .. "ReaTrak_Classes/Class - Label.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Knob.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Tabs.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Slider.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Button.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Menubox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Textbox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Listbox.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Frame.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Options.lua")()
GUI.req(script_path .. "ReaTrak_Classes/Class - Window.lua")()

--------------------------------
 --REATRAK LOCAL GUI LIBRARY end
--------------------------------

--[[
--------------------------------
 --LOKASENNA GUI LIBRARY start
--------------------------------

-- NoIndex: true

--[[
  Lokasenna_GUI example

  - Getting user input before running an action; i.e. replacing GetUserInputs

]]--

--[[

-- The Core library must be loaded prior to anything else
reaper.MB("Using Lokasenna_GUI library", "Notice", 0)
    
local lib_path = reaper.GetExtState("Lokasenna_GUI", "lib_path_v2")
if not lib_path or lib_path == "" then
    reaper.MB("Couldn't load the Lokasenna_GUI library. Please run 'Script: Set Lokasenna_GUI v2 library path.lua' in your Action List.", "Whoops!", 0)
    return
end
loadfile(lib_path .. "Core.lua")()

GUI.req("Classes/Class - Slider.lua")()
GUI.req("Classes/Class - Button.lua")()
GUI.req("Classes/Class - Menubox.lua")()
GUI.req("Classes/Class - Options.lua")()
GUI.req("Classes/Class - Label.lua")()
GUI.req("Classes/Class - Frame.lua")()
GUI.req("Classes/Class - Textbox.lua")()

--------------------------------
 --LOKASENNA GUI LIBRARY end
--------------------------------
--]]

-- If any of the requested libraries weren't found, abort the script nicely.
if missing_lib then return 0 end

--Tabs

GUI.New("tabs",      "Tabs",           1, 0, 0, 25, 20, "Track,Choice", 60)
--GUI.New("tab_bg",     "Frame",          2, 0, 0, 600, 20, true, true, "elm_bg", 1)
GUI.elms.tabs.col_txt = "chorus_fill"

-- Telling the tabs which z layers to display
-- See Classes/Tabs.lua for more detail
GUI.elms.tabs:update_sets(
  --  Tab
  --               Layers
  {     [1] =     {3,6},
    [2] =     {2,4,7}, --Include layer 2,6 on Tab 2 Chord Root Radio and Insert Root Note Button
    [3] =     {2,5,6}, --Include layer 2 on Tab 3 Chord Root Radio and Insert Root Note Button
    [4] =     {6},
    [5] =     {7},
    [6] =     {8},
    [7] =     {9},
    [8] =     {10},
    [9] =     {11},
    [10] =     {12},
    [11] =     {13},
    [12] =     {14},
    [13] =     {15},
    [14] =     {16},
    [15] =     {17},
    [16] =     {18},
    [17] =     {19},
    [18] =     {20},
    [19] =     {21},
    [20] =     {22},
    
  }
)


--GUI.New("tabs",   "Tabs",     1, 0, 0, 64, 20, "Stuff", 16)
GUI.New("tab_bg",  "Frame",    2, 0, 0, 448, 20, false, true, "elm_bg", 0)
-- Button Colors  = {r, g, b, transparency}

GUI.colors["count_in"] = {255, 124, 192, 255}
GUI.colors["intro_post_fill"] = {119, 17, 174, 255}
GUI.colors["intro"] = {159, 22, 232, 255}
GUI.colors["intro_fill"] = {183, 128, 237, 255}
GUI.colors["verse_post_fill"] = {17, 39, 174, 255}
GUI.colors["verse"] = {55, 118, 235, 255}
GUI.colors["verse_fill"] = {113, 190, 241, 255}
GUI.colors["verse_ending"] = {151, 208, 245, 255}
GUI.colors["bridge_post_fill"] = {206, 105, 20, 255}
GUI.colors["bridge"] = {234, 133, 48, 255}
GUI.colors["bridge_fill"] = {239, 164, 100, 255}
GUI.colors["pre_chorus_post_fill"] = {206, 179, 20, 255}
GUI.colors["pre_chorus"] = {234, 208, 48, 255}
GUI.colors["pre_chorus_fill"] = {244, 231, 151, 255}
GUI.colors["chorus_post_fill"] = {11, 116, 39, 255}
GUI.colors["chorus"] = {17, 174, 59, 255}
GUI.colors["chorus_fill"] = {80, 237, 123, 255}
GUI.colors["chorus_ending"] = {158, 254, 182, 255}
GUI.colors["play_anywhere"] = {228, 26, 39, 250}
GUI.colors["drum_riff"] = {115, 23, 17, 255}
GUI.colors["hold"] = {191, 191, 191, 255}
GUI.colors["shot"] = {127, 127, 127, 255}
GUI.colors["rest"] = {0, 0, 0, 255}
GUI.colors["darkred"] = {185, 74, 97, 250}

--Text Colors

GUI.colors["btn_txt1"] = {255, 255, 255, 255} --white
GUI.colors["btn_txt2"] = {155, 155, 155, 255} --gray
GUI.colors["btn_txt3"] = {0, 0, 0, 255} --black

------------------------------------
-------- Functions  ----------------
------------------------------------
osversion = reaper.GetOS()

retval_folder, path = reaper.BR_Win32_GetPrivateProfileString("reaper", "biab_drums_folder", "", inipath)

retval_ext, realdrums_extension = reaper.BR_Win32_GetPrivateProfileString("reaper", "biab_drums_ext", "", inipath)
if realdrums_extension =="" then
  --Msg("retval_ext")
  realdrums_extension = ".wma"
end  

drive = string.sub(path, 1, 1)
drum_demo_path = drive..":\\bb\\RealTracks\\Data\\RealDrums Demos Audio\\"

--Msg("Set Path= "..path)

search_words = "%w"

current_drum = 0

search_flag = 0

--realdrums_extension = "xxx"

user_offset = "0"






local function btn_click()
  
  -- Grab all of the user's settings into local variables,
  -- just to make it less awkward to work with
  local mode, thresh = GUI.Val("mnu_mode"), GUI.Val("sldr_thresh")
  local opts = GUI.Val("chk_opts")
  local time_sel, sel_track, glue = opts[1], opts[2], opts[3]
  
  -- Be nice, give the user an Undo point
  reaper.Undo_BeginBlock()
  
  reaper.ShowMessageBox(
    "This is where we pretend to perform some sort of fancy operation with the user's settings.\n\n"
    .."Working in "..tostring(GUI.elms.mnu_mode.optarray[mode])
    .." mode with a threshold of "..tostring(thresh).."db.\n\n"
    .."Apply only to time selection: "..tostring(time_sel).."\n"
    .."Apply only to selected track: "..tostring(sel_track).."\n"
    .."Glue the processed items together afterward: "..tostring(glue)
  , "Yay!", 0)
  
  
  reaper.Undo_EndBlock("Typical script options", 0)     
  
  -- Exit the script on the next update
  GUI.quit = true
  
end

function btn_click_refresh()
  
  --GetFiles(path)
  GetPathSeparator()
  filename_table()
  --GUI.elms.file_list:init()
  --GUI.elms.file_list2:init()
  
  --GUI.elms.file_list.list = drum_path_files
  --GUI.elms.file_list:redraw()
  
  GUI.elms.file_list2.list = drum_path_files2
  GUI.elms.file_list2:redraw()
  

  --[[
  function GUI.elms.file_list:onmouseup()
      GUI.Listbox.onmouseup(self)
      listbox_val = GUI.Val("file_list")
      midifile_path = drum_path_files[listbox_val]
  
      --reaper.ShowConsoleMsg("Current index: " .. drum_path_files[listbox_val] .."\n")
      GUI.elms.my_frm4:ondelete()
      GUI.New("my_frm4",      "Frame",           5, 10, 300, 590, 35, true, true, "elm_bg", 4)
      GUI.elms.my_frm4.text = drum_path_files[listbox_val] 
      GUI.elms.my_frm4.col_txt = "white"
      GUI.elms.my_frm4:init()
      
  end
  --]]
  function GUI.elms.file_list2:onmouseup()
      GUI.Listbox.onmouseup(self)
      listbox_val2 = GUI.Val("file_list2")
      drumfile_path2 = drum_path_files[listbox_val2]
  
      --reaper.ShowConsoleMsg("Current index: " .. midifile_path2 .."\n")
      GUI.elms.my_frm6:ondelete()
      GUI.New("my_frm6",      "Frame",           4, 10, 380, 480, 35, true, true, "elm_bg", 4)
      GUI.elms.my_frm6.text = drum_path_files3[listbox_val2] --" Choose the Root of the Chord then the Chord type or add the Root Note for / Slash Chords"
      GUI.elms.my_frm6.col_txt = "white"
      GUI.elms.my_frm6:init()    
  end 
 
  --view_opt = GUI.elms.view_opt.optarray[ GUI.Val("view_opt") ]
  --if view_opt == "Filename" then btn_click_file() end
  --if view_opt == "Pathname" then btn_click_path() end
end

function search_folder()

  search_words = GUI.Val("my_search")
  if search_words == "" then search_words = "%w" end
  --GetFiles(path)
  search_flag = 1
  filename_table()
  btn_click_refresh()

end

function browse_folder()

  retval, folder = reaper.JS_Dialog_BrowseForFolder( "Browse for folder", path  )
  path = folder
  --Msg("path= "..path)
  reaper.BR_Win32_WritePrivateProfileString( "reaper", "biab_drums_folder", path, inipath )
  --Msg("Path set to: "..path)
  drive = string.sub(path, 1, 1)
  drum_demo_path = drive..":\\bb\\RealTracks\\Data\\RealDrums Demos Audio\\"
  search_flag = 0
  btn_click_refresh()
  
end

function selected_drum()

  GUI.elms.file_list2.list = drum_path_files2
  GUI.elms.file_list2:redraw()
  if not drum_path_files2 then return end
  current_drum = 1
  btn_click_create_file()

end

 function firstToUpper(str)
     return (str:gsub("^%l", string.upper))
 end
 
 
function GetFilename(path)   
    local start, finish = path:find('[%w%s!-={-|]+[_%.].+')   
    return path:sub(start,#path) 
end 

function GetFileExtension(file_name)
  return file_name:match("^.+(%..+)$")
end

function GetFileName(url)
  return url:match("^.+/(.+)$")
end

function export(f, variable)
  f:write(variable)
  f:write("\n")
end

function rgbToHex(r, g, b)
    return string.format("#%0.2X%0.2X%0.2X", r, g, b)
end

function table.val_to_str ( v )
  if "string" == type( v ) then
    v = string.gsub( v, "\n", "\\n" )
    if string.match( string.gsub(v,"[^'\"]",""), '^"+$' ) then
   return "'" .. v .. "'"
    end
    return '"' .. string.gsub(v,'"', '\\"' ) .. '"'
  else
    return "table" == type( v ) and table.tostring( v ) or
   tostring( v )
  end
end

function table.key_to_str ( k )
  if "string" == type( k ) and string.match( k, "^[_%a][_%a%d]*$" ) then
    return k
  else
    return "[" .. table.val_to_str( k ) .. "]"
  end
end

function table.tostring( tbl )
  local result, done = {}, {}
  for k, v in ipairs( tbl ) do
    table.insert( result, table.val_to_str( v ) )
    done[ k ] = true
  end
  for k, v in pairs( tbl ) do
    if not done[ k ] then
   table.insert( result,
     table.key_to_str( k ) .. "=" .. table.val_to_str( v ) )
    end
  end
  return "{" .. table.concat( result, "," ) .. "}"
end

function time_to_region(beat_time)
   
   markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, beat_time )
   retval, isrgn, pos, rgnend, beat_time_name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
   --current_name = beat_time_name
   return beat_time_name
end



function round(x)
  return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
end

function last_bar()

   export(f, "| " .. b1b1 .. " | ")
end

local function btn_click_region_number()

  reaper.Main_OnCommand(42435,0) -- Ruler: Display region number even if region is named

end

function GetPathSeparator()
  if osversion:find("Win") then return "\\"
  else return "/" end
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function string:split(sep)
  local sep, fields = sep or ":", {}
  local pattern = string.format("([^%s]+)", sep)
  self:gsub(pattern, function(c) fields[#fields+1] = c end)
  return fields
end

function NearestValue(table, number)
    local smallestSoFar, smallestIndex
    for i, y in ipairs(table) do
        if not smallestSoFar or (math.abs(number-y) < smallestSoFar) then
            smallestSoFar = math.abs(number-y)
            smallestIndex = i
        end
    end
    return smallestIndex, table[smallestIndex]
end

function position_in_table(table,key_name)

 local index={}
 for k,v in pairs(table) do
    index[v]=k
 end
 return index[key_name]
end


function GetFiles(path)
  local tree = {}
  local subDirIndex, fileIndex = 0, 0
  local pathChild

  if path ~= nil then 
    repeat
      pathChild = reaper.EnumerateSubdirectories(path, subDirIndex)
        if pathChild then
          local tmpPath = GetFiles(path .. GetPathSeparator() .. pathChild)
            for i = 1, #tmpPath do
              tree[#tree + 1] = tmpPath[i]
            end
        end
        subDirIndex = subDirIndex + 1
    until not pathChild

    repeat
      local fileFound = reaper.EnumerateFiles(path, fileIndex)
        --search_words = "Nash 120"
        token_count = 0
        _,n = search_words:gsub("%S+","")
        --Msg(n)
        match_count = n
      if fileFound and string.match(fileFound, ".txt") then  
        --for token in string.gmatch(search_words, "[^%s]+") do
          --if string.match(fileFound, token) or string.match(fileFound, token:lower()) or string.match(fileFound, firstToUpper(token)) then 
            --token_count = token_count +1
          --end 
        --end  
        --if token_count == match_count then 
          
          --if fileFound then --and string.match(fileFound, ".txt") then
          
            tree[#tree + 1] = path .. GetPathSeparator() .. fileFound
          --end
        --end 
      end  
        fileIndex = fileIndex + 1
    until not fileFound
  end
  return tree
end

function filename_table()
  
  --Msg("Table Length "..tablelength(drum_path_files))
  if search_flag == 0 then
    drum_path_files = GetFiles(path)
  end  
  drum_path_files2 = {}
  drum_path_files3 = {}
  drum_path_files3 = {}
  for i = 1, tablelength(drum_path_files) do
    
    filetxt = (drum_path_files[i])
    --Msg(filetxt)
    --dir1 = string.gsub(filetxt, "\\[^\\]*$", "")
    --dir = dir1 .. GetPathSeparator()
    txt_filename1 = string.match(filetxt, "\\[^\\]*$")
    --txt_filename1 = string.match(filetxt, ".txt")
    txt_filename = string.gsub(txt_filename1, "\\", "")
    txt_filename = string.gsub(txt_filename, "\\", "")
    txt_filename = string.gsub(txt_filename, "\"", "")
   
    for token in string.gmatch(search_words, "%S+") do 
      if string.find(string.lower(txt_filename), string.lower(token)) then
      table.insert(drum_path_files2,txt_filename)
      table.insert(drum_path_files3,filetxt)
       
    end
      
    end
  end  
end


local function btn_click_new_region()
    retval_measures, insert_measures_retvals_csv = reaper.GetUserInputs( "Insert Measures", 1, "Number of Measures", "" )
    
    
    time = reaper.GetCursorPosition()
    
    reaper.Main_OnCommand(40625,0) -- Time selection: Set start point
    if retval_measures == true then
    for i = 0, insert_measures_retvals_csv - 1 do
        reaper.Main_OnCommand(41042,0) -- Move edit cursor forward one measure
    end
    
    reaper.Main_OnCommand(40626,0) -- Time selection: Set end point
    
    reaper.Main_OnCommand(40174,0) -- Markers: Insert region from time selection
    
    reaper.Main_OnCommand(40635,0)  -- Time selection: Remove time selection 
    
    --commandID03 = reaper.NamedCommandLookup("_RS0b4230c08f384a4318c16aac4e2404c9fef86887")
    --reaper.Main_OnCommand(commandID03, 0)  -- Script: ReaTrak Snap all regions to grid.eel
          
    reaper.SetEditCurPos(time, 1, 0)
    
    end
    end

local function btn_click_edit_chord()
    reaper.Main_OnCommand(40616, 0) -- Markers: Edit region near cursor
    end

local function btn_click_chord_split()
    retval, num_markers, num_regionsOut = reaper.CountProjectMarkers(0)
    
    desired_region_id = num_regionsOut
    
    time = reaper.GetCursorPosition()
    
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion(0, time)
    
    retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3(0, regionidx)
    
    if time == pos then goto finish end
    
    if time < rgnend then
    
    reaper.SetProjectMarker3( 0, markrgnindexnumber, 1, pos, time, name, color )
    
    reaper.AddProjectMarker2(0, 1, time, rgnend, name, desired_region_id, color)
    end
    
    ::finish::  
    end


local function btn_click_chord_pre()
    edit_pos = reaper.GetCursorPosition()
    
    play = reaper.GetPlayState()
    if play > 0 then
      pos = reaper.GetPlayPosition()
    else
      pos = edit_pos
    end
    
    count_markers_regions, count_markersOut, count_regionsOut = reaper.CountProjectMarkers(0)
    
    i=1
    repeat
      iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,count_markers_regions-i)
      if iRetval >= 1 then
        if bIsrgnOut == true and iPosOut < pos then
          -- ACTION ON REGIONS HERE
          reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
          break
        end
        i = i+1
      end
    until iRetval == 0
      
   
    end
 
local function btn_click_bar_pre()
    reaper.Main_OnCommand(41043, 0) -- Move edit cursor back one measure
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)
    end

local function btn_click_beat_pre()
    reaper.Main_OnCommand(41045, 0) -- Move edit cursor back one beat
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)
    end
  
local function btn_click_chord_next()
    edit_pos = reaper.GetCursorPosition()
    
    play = reaper.GetPlayState()
    if play > 0 then
      pos = reaper.GetPlayPosition()
    else
      pos = edit_pos
    end
    
    i=0
    repeat
      iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,i)
      if iRetval >= 1 then
        if bIsrgnOut == true and iPosOut > pos then
          -- ACTION ON REGIONS HERE
          reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
          break
        end
        i = i+1
      end
    until iRetval == 0
      
    
    end

local function btn_click_bar_next()
    --reaper.Main_OnCommand(41040, 0) -- Move edit cursor to start of next measure
    reaper.Main_OnCommand(41042, 0) -- Move edit cursor forward one measure
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)    
    end

local function btn_click_beat_next()
    reaper.Main_OnCommand(41044, 0) -- Move edit cursor forward one beat
    time = reaper.GetCursorPosition()
    grid_pos = reaper.SnapToGrid(0, time)
    reaper.SetEditCurPos2(0, grid_pos, false, false)    
    end

function btn_click_chord()
    chord_name = GUI.Val("my_chord")
    retval, num_markers, num_regionsOut = reaper.CountProjectMarkers(0)
    
    desired_region_id = num_regionsOut
    
    time = reaper.GetCursorPosition()
    
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion(0, time)
    
    retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3(0, regionidx)
    
    if time == pos then goto finish end
    
    if time < rgnend then
    
    reaper.SetProjectMarker3( 0, markrgnindexnumber, 1, pos, time, name, color )
    
    reaper.AddProjectMarker2(0, 1, time, rgnend, name, desired_region_id, color)
    
    goto finish 
    end
    
    ::finish::
    
    
  time = reaper.GetCursorPosition()
  markrgnindexnumber, rgnendOut = reaper.GetLastMarkerAndCurRegion(0, time)
  retval, isrgnOut, posOut, rgnendOut, nameOut, markrgnindexnumberOut = reaper.EnumProjectMarkers(rgnendOut)
  clear_name_flag = 0 --this flag is needed in the SetProjectMarker4 function to enable the region name to be cleared
    
  newName = chord_name
  
  reaper.SetProjectMarker4(0, markrgnindexnumberOut, true, posOut, rgnendOut, newName, 0, clear_name_flag)
  chord_type = ""
  btn_click_chord_next()
    end

function btn_click_verse_post_fill()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(17,39,174)|0x1000000), 0)
    btn_click_chord_next()
    end
    
function btn_click_verse()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(55,118,235)|0x1000000), 0)
    btn_click_chord_next()
    end    

function btn_click_verse_fill()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(113,190,241)|0x1000000), 0)
    btn_click_chord_next()
    end

function btn_click_verse_ending()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(151,208,254)|0x1000000), 0)
    btn_click_chord_next()
    end

function btn_click_chorus_post_fill()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(11,116,39)|0x1000000), 0)
    btn_click_chord_next()
    end

function btn_click_chorus()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(17,174,59)|0x1000000), 0)
    btn_click_chord_next()
    end    

function btn_click_chorus_fill()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(80,237,123)|0x1000000), 0)
    btn_click_chord_next()
    end    
    
function btn_click_chorus_ending()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(158,245,182)|0x1000000), 0)
    btn_click_chord_next()
    end    
    
function btn_click_count_in()
    time =  reaper.GetCursorPosition()
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, time )
    retval, isrgn, pos, rgnend, name_str, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    reaper.SetProjectMarker4( 0, markrgnindexnumber, isrgn, pos, rgnend, name_str,(reaper.ColorToNative(255,128,192)|0x1000000), 0)
    btn_click_chord_next()

    end    



function Main()

  

  retval_inputs, key = reaper.GetUserInputs( "Set Song Key", 1, "Key", "C" )
  

  master_tempo = reaper.Master_GetTempo()

  f = io.open(file, "w")
  
  export(f, "Name: ".. name_input)
  export(f, "Meter: 4/4")
  export(f, "Style: Swing")
  export(f, "Key: "..key)
  export(f, "Tempo: ".. round(master_tempo))
 
--[[
  Name: Guitar, 12-String Acoustic, Strumming Ev 120 demo
  Meter: 4/4
  Style: Swing
  Key: D
  Tempo: 120
  Chorus: bars 1 to 96 (repeat 1 times)
  Sections: 1A 9B 17A 25B 33A 41B 49A 57B 65A 73B 81A 89B 97A
--]] 

  retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, 0 )
   
  retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
  
  --Msg("start ".. measures)
  
  
  retval, num_markers, num_regions = reaper.CountProjectMarkers( 0 )
  --Msg("num_regions ".. num_regions)
  for i = 0, num_regions -1 do
  retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, i )
  if color == reaper.ColorToNative(17,39,174)|0x1000000 or color == reaper.ColorToNative(11,116,39)|0x1000000 then
     retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
     start_measure = measures break 
  end
  end
  
  retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, num_regions -2 )
   
  retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
  
  end_bar = measures
  
  export(f, "Chorus: bars ".. 1 .." to ".. measures-(start_measure -1) .. " (repeat 1 times)")
  
  part_marker_count = 0
  
  offset = 0
  
  first_bar = 0
  
  section_table = {}
  
  for i = 0, num_regions -1 do
    retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, i )
    
    --Msg(i .." ".. name)
    
    retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
    --Msg(name .." ".. measures .." ".. cml .." ".. fullbeats .." ".. cdenom .." ".. (fullbeats/cml)-measures )
    --if color == reaper.ColorToNative(255,128,192)|0x1000000 then offset = 2 Msg("offset ".. offset)end
    --reaper.ColorFromNative(iColorOur)
    if color == reaper.ColorToNative(17,39,174)|0x1000000 or color == reaper.ColorToNative(11,116,39)|0x1000000 then
    
    part_marker_count = part_marker_count +1
    
    if first_bar == 0 then 
    
    retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
    
    first_bar = measures
    
    first_bar_region = i
    
    first_bar_time = reaper.TimeMap2_beatsToTime( 0, fullbeats )
    
    --Msg("first_bar_time ".. first_bar_time .." pos ".. pos)
    
    retval, qn_start, qn_end, timesig_num, timesig_denom, tempo = reaper.TimeMap_GetMeasureInfo( 0, measures )
    
    --Msg("qn_start ".. qn_start)
    end
    
    if color == reaper.ColorToNative(17,39,174)|0x1000000 then
    part_marker = "A" 
    table.insert(section_table,((measures)-start_measure+1) .. part_marker)
    end 
    
    if color == reaper.ColorToNative(11,116,39)|0x1000000 then
    part_marker = "B"
    table.insert(section_table,((measures)-start_measure+1) .. part_marker)
    end 
    
    end
    
    if color == reaper.ColorToNative(151,208,254)|0x1000000 or color == reaper.ColorToNative(158,245,182)|0x1000000 then   
    
    if color == reaper.ColorToNative(151,208,254)|0x1000000 then
    part_marker = "A" 
    table.insert(section_table,((measures)-start_measure+1) .. part_marker)
    end 
    
    if color == reaper.ColorToNative(158,245,182)|0x1000000 then
    part_marker = "B"
    table.insert(section_table,((measures)-start_measure+1) .. part_marker)
    end       
       
    end     
    
    
    
    
    --Msg(part_marker)
    --Msg(measures+1)
    
    
  end

       
    section_markers = table.tostring( section_table )
    section_markers = string.gsub(section_markers, [[","]], " ")
    section_markers = string.gsub(section_markers, [["]], " ")
    section_markers = string.gsub(section_markers, [[{]], "")
    section_markers = string.gsub(section_markers, [[}]], "")
    export(f, "Sections:".. section_markers)
  --Msg(end_bar+1)
  final_time = end_bar+1
  end_time = reaper.TimeMap2_beatsToTime( 0, 3, final_time ) 
  --Msg("end_time ".. end_time)
  
 
  
  for i = first_bar, end_bar -1 do
    --markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, beat_time )
    --retval, isrgn, pos, rgnend, beat_time_name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
  --Msg("current_name "..current_name) 
    if i == first_bar then
    beat_time = reaper.TimeMap2_beatsToTime( 0, 0, i )
    markeridx, regionidx = reaper.GetLastMarkerAndCurRegion( 0, beat_time )
    retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, regionidx )
    first_bar_region = regionidx       
    else 
    beat_time = reaper.TimeMap2_beatsToTime( 0, 0, first_bar )
    end
    --Msg("current_name "..current_name) 
    retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, beat_time )  
  
    --end_time = reaper.TimeMap2_beatsToTime( 0, 3, end_bar )
    
    bar_1_beat_1 = reaper.TimeMap2_beatsToTime( 0,0, measures )
    b1b1 = time_to_region(bar_1_beat_1) current = b1b1
    if bar_1_beat_1 > end_time then last_bar() break end
    bar_1_beat_2 = reaper.TimeMap2_beatsToTime( 0, 1, measures )
    b1b2 = time_to_region(bar_1_beat_2) 
    if b1b2 == current then b1b2 = "_" end
    current = b1b2
    if bar_1_beat_2 > end_time then last_bar() break end
    bar_1_beat_3 = reaper.TimeMap2_beatsToTime( 0, 2, measures )
    b1b3 = time_to_region(bar_1_beat_3) 
    if b1b3 == current then b1b3 = "_" end
    current = b1b3
    if bar_1_beat_3 > end_time then last_bar() break end
    bar_1_beat_4 = reaper.TimeMap2_beatsToTime( 0, 3, measures )
    b1b4 = time_to_region(bar_1_beat_4) 
    if b1b4 == current then b1b4 = "_" end
    current = b1b4 
    if bar_1_beat_4 > end_time then last_bar() break end

    bar_2_beat_1 = reaper.TimeMap2_beatsToTime( 0, 0, measures+1 )
    b2b1 = time_to_region(bar_2_beat_1) current = b2b1
    if bar_2_beat_1 > end_time then last_bar() break end
    bar_2_beat_2 = reaper.TimeMap2_beatsToTime( 0, 1, measures+1 )
    b2b2 = time_to_region(bar_2_beat_2) 
    if b2b2 == current then b2b2 = "_" end
    current = b2b2
    if bar_2_beat_2 > end_time then last_bar() break end
    bar_2_beat_3 = reaper.TimeMap2_beatsToTime( 0, 2, measures+1 )
    b2b3 = time_to_region(bar_2_beat_3) 
    if b2b3 == current then b2b3 = "_" end
    current = b2b3
    if bar_2_beat_3 > end_time then last_bar() break end
    bar_2_beat_4 = reaper.TimeMap2_beatsToTime( 0, 3, measures+1 )
    b2b4 = time_to_region(bar_2_beat_4) 
    if b2b4 == current then b2b4 = "_" end
    current = b2b4              
    if bar_2_beat_4 > end_time then last_bar() break end
    
    bar_3_beat_1 = reaper.TimeMap2_beatsToTime( 0, 0, measures+2 )
    b3b1 = time_to_region(bar_3_beat_1) current = b3b1
    if bar_3_beat_1 > end_time then last_bar() break end
    bar_3_beat_2 = reaper.TimeMap2_beatsToTime( 0, 1, measures+2 )
    b3b2 = time_to_region(bar_3_beat_2) 
    if b3b2 == current then b3b2 = "_" end
    current = b3b2
    if bar_3_beat_2 > end_time then last_bar() break end
    bar_3_beat_3 = reaper.TimeMap2_beatsToTime( 0, 2, measures+2 )
    b3b3 = time_to_region(bar_3_beat_3) 
    if b3b3 == current then b3b3 = "_" end
    current = b3b3
    if bar_3_beat_3 > end_time then last_bar() break end
    bar_3_beat_4 = reaper.TimeMap2_beatsToTime( 0, 3, measures+2 )
    b3b4 = time_to_region(bar_3_beat_4) 
    if b3b4 == current then b3b4 = "_" end
    current = b3b4
    if bar_3_beat_4 > end_time then last_bar() break end

    bar_4_beat_1 = reaper.TimeMap2_beatsToTime( 0, 0, measures+3 )
    b4b1 = time_to_region(bar_4_beat_1) current = b4b1
    if bar_4_beat_1 > end_time then last_bar() break end
    bar_4_beat_2 = reaper.TimeMap2_beatsToTime( 0, 1, measures+3 )
    b4b2 = time_to_region(bar_4_beat_2) 
    if b4b2 == current then b4b2 = "_" end
    current = b4b2
    if bar_4_beat_2 > end_time then last_bar() break end
    bar_4_beat_3 = reaper.TimeMap2_beatsToTime( 0, 2, measures+3 )
    b4b3 = time_to_region(bar_4_beat_3) 
    if b4b3 == current then b4b3 = "_" end
    current = b4b3
    if bar_4_beat_3 > end_time then last_bar() break end
    bar_4_beat_4 = reaper.TimeMap2_beatsToTime( 0, 3, measures+3 )
    b4b4 = time_to_region(bar_4_beat_4) 
    if b4b4 == current then b4b4 = "_" end
    current = b4b4
    if bar_4_beat_4 > end_time then last_bar() break end
    --Msg("bar_4_beat_4 ".. bar_4_beat_4 .." end_time ".. end_time)
    
    line = 
    "| " .. b1b1 .. " " .. b1b2 .. " " .. b1b3 .. " " .. b1b4 .. " | " .. b2b1 .. " " .. b2b2 .. " " .. b2b3 .. " " .. b2b4 .. " | " .. b3b1 .. " " .. b3b2 .. " " .. b3b3 .. " " .. b3b4 .. " | " .. b4b1 .. " " .. b4b2 .. " " .. b4b3 .. " " .. b4b4 .. " |"
    export(f, line)
    
    first_bar = first_bar +4
    
    --if first_bar => end_bar then break end
    
  end  
  
 

  -- CLOSE FILE
  f:close() -- never forget to close the file
  
  local info = debug.getinfo(1,'S');
  script_path = info.source:match[[^@?(.*[\/])[^\/]-$]]
 
  --file
  
  --filename_no_ext = string.gsub(file, '[.]%w%w%w$','')
  
  mjb_mid_file = file .. ".mid"
  
  --Msg(mjb_mid_file)
  
  file2 = tostring([["]].. file ..[["]])
  
  --Msg(file2)
  
  mjb2lite_path = script_path .. "mjb2lite\\"
  
  --Msg(mjb2lite_path)
  
  reaper.ExecProcess([[cmd.exe /C " cd ]] .. mjb2lite_path .. [[& mjb2lite.exe ]].. file2 ..[["]],0)
  --os.execute([[cmd.exe /C " cd ]] .. script_path .. [[ mjb2lite/ & "mjb2lite.exe" ]].. file2 ..[["]])
  --reaper.ExecProcess([[cmd.exe /C " cd ]] .. script_path .. [[sonic/win32/ & set VAMP_PATH=]] .. script_path .. [[sonic/win32/vamp; ]].. script_path .. [[ & "sonic-annotator.exe" -d vamp:nnls-chroma:chordino:simplechord -w csv "]].. filename ..[["]],0)
  
  
  reaper.InsertMedia( mjb_mid_file, 1 )

end 

local function move_selected_items()

  function main()
    cnt_items = reaper.CountSelectedMediaItems(0)
    if cnt_items == 0 then return end
    
    new_track = reaper.GetSelectedTrack(0,0)
    if not new_track then return end
    
    local items = {}
    for i = 1, cnt_items do
      item = reaper.GetSelectedMediaItem(0,i-1)  
      items[i] =  reaper.BR_GetMediaItemGUID( item )
    end
    
    for i = 1, #items do
      item = reaper.BR_GetMediaItemByGUID( 0, items[i] )
      if item == nil then return end
      item_track = reaper.GetMediaItem_Track(item)
    
      if new_track ~= item_track then 
        local _, item_chunk =  reaper.GetItemStateChunk(item, '')
        reaper.DeleteTrackMediaItem(item_track, item)
        new_item = reaper.AddMediaItemToTrack(new_track)
        reaper.SetItemStateChunk(new_item, item_chunk)
      end
    end
    reaper.UpdateArrange()
  end
  
  reaper.Undo_BeginBlock()
  main()
  reaper.Undo_EndBlock('Move selected items to selected track ', 0)

end

local function btn_click_create_stems()
  
  reaper.Undo_BeginBlock() 
  sep = "," -- default sep
  popup = true
  
  --[[
  col_pos = 3 -- Position column index in the CSV
  col_pos_end = 4 -- Length column index in the CS
  col_len = 5 -- Length column index in the CSV
  col_name = 2 -- Name column index in the CSV
  col_color = 6
  --]]
  col_stem = 1
  --[[
  col_data = 3
  col_source = 4
  col_bpm = 5
  col_timesig = 8
  col_source_start = 9 -- - (beats * 1200) 
  col_source_offset = 12
  col_source_end = 13 -- / 1200 (/col_timesig)
  col_source_dest = 18
  col_bar_dest = 20 -- +3 including count-in
  col_transpose = 23
  col_is_drums = 29
  --]]
  ------------------------------------------------------- END OF USER CONFIG AREA
  
  function ColorHexToInt(hex)
    hex = hex:gsub("#", "")
    local R = tonumber("0x"..hex:sub(1,2))
    local G = tonumber("0x"..hex:sub(3,4))
    local B = tonumber("0x"..hex:sub(5,6))
    return reaper.ColorToNative(R, G, B)
  end
  
  function GetPath(str)
      return str:match("(.*[/\\])")
  end
  
  function GetFilename(path)   
      local start, finish = path:find('[%w%s!-={-|]+[_%.].+')   
      return path:sub(start,#path) 
  end
  
  --function GetFileName(url)
  --  return url:match("^.+/(.+)$")
  --end
  
  function GetFileExtension(url)
    return url:match("^.+(%..+)$")
  end
  
  
  function round(x)
    return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
  end
  
  function create_stem_track(stem_name)
  
    reaper.Main_OnCommand(40062,0) -- Track: Duplicate tracks
    
    sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
    
    reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
    
    reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
    
    item_count = reaper.CountTrackMediaItems( sel_track )
    
    for i = 0, item_count -1 do
      
      item2 = reaper.GetSelectedMediaItem(0, i)
      take2 = reaper.GetActiveTake(item2)
      item_source = filenamenoext..stem_name..extension
      item_source = string.gsub(item_source, "Style", "")
      item_source = string.gsub(item_source, "STYLE", "")
      item_source = string.gsub(item_source, "\\", "\\".."\\")
      --Msg(filenamenoext.."_"..stem_name..extension)
      --Msg(item_source)
      reaper.BR_SetTakeSourceFromFile(take2, item_source, true)
      
    end  
      retval, namestring = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", stem_name, true )
      
      reaper.UpdateArrange() 
      --reaper.Main_OnCommand(40441, 0) -- rebuild peaks for selected items 
      reaper.Main_OnCommand(40047, 0) -- Peaks: Build any missing peaks
      
      
      
  
  end
  
  
  -- Optimization
  local reaper = reaper
  
  -- CSV to Table
  -- http://lua-users.org/wiki/LuaCsv
  function ParseCSVLine (line,sep)
    local res = {}
    local pos = 1
    sep = sep or ','
    while true do
      local c = string.sub(line,pos,pos)
      if (c == "") then break end
      if (c == '"') then
        -- quoted value (ignore separator within)
        local txt = ""
        repeat
          local startp,endp = string.find(line,'^%b""',pos)
          txt = txt..string.sub(line,startp+1,endp-1)
          pos = endp + 1
          c = string.sub(line,pos,pos)
          if (c == '"') then txt = txt..'"' end
          -- check first char AFTER quoted string, if it is another
          -- quoted string without separator, then append it
          -- this is the way to "escape" the quote char in a quote. example:
          --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
        until (c ~= '"')
        table.insert(res,txt)
        assert(c == sep or c == "")
        pos = pos + 1
      else
        -- no quotes used, just look for the first separator
        local startp,endp = string.find(line,sep,pos)
        if (startp) then
          table.insert(res,string.sub(line,pos,startp-1))
          pos = endp + 1
        else
          -- no separator found -> use rest of string and terminate
          table.insert(res,string.sub(line,pos))
          break
        end
      end
    end
    return res
  end
  
  
  -- UTILITIES -------------------------------------------------------------
  
  -- Display a message in the console for debugging
  function Msg(value)
    if console then
      reaper.ShowConsoleMsg(tostring(value) .. "\n")
    end
  end
  
  function ReverseTable(t)
      local reversedTable = {}
      local itemCount = #t
      for k, v in ipairs(t) do
          reversedTable[itemCount + 1 - k] = v
      end
      return reversedTable
  end
  
  --------------------------------------------------------- END OF UTILITIES
  
  function read_lines(filepath)
    --Msg("filepath "..filepath)
    lines = {}
  
    local f = io.input(filepath)
    repeat
  
      s = f:read ("*l") -- read one line
  
      if s then  -- if not end of file (EOF)
        table.insert(lines, ParseCSVLine (s,sep))
      end
  
    until not s  -- until end of file
  
    f:close()
  
  end
  
  -- Main function
  function main()
  
    folder = tostring(filetext):match[[^@?(.*[\/])[^\/]-$]]
  
    for i, line in ipairs( lines ) do
      if i > 2 then
      
        local stem_name = line[col_stem]
        
        create_stem_track(stem_name)    
       
      end    
    end  
    
  end  
    
   sel_track = reaper.GetSelectedTrack2( 0, 0, 0 ) 
    
   first_item = reaper.GetTrackMediaItem( sel_track, 0 )
   
   take = reaper.GetMediaItemTake( first_item, 0)
   
   source = reaper.GetMediaItemTake_Source(take)
   
   filenamepath = reaper.GetMediaSourceFileName( source )
   
   path = GetPath(filenamepath)
   
   
   --Msg("filenamepath "..filenamepath)
   --Msg("path "..path)
   
   filename = GetFilename(filenamepath)
   --Msg("filename "..filename)
   extension = GetFileExtension(filename)
   --Msg("extension "..extension)
   filenamenoext = string.gsub(filenamepath, extension, "")
   
   filenamenoext = string.gsub(filenamenoext, "Style", "")
   filenamenoext = string.gsub(filenamenoext, "STYLE", "")
   --Msg("filenamenoext "..filenamenoext)
   steminfopath = (path.."StemInfo.txt")
   --Msg("steminfopath "..steminfopath)
  read_lines(steminfopath)
  filetxt = steminfopath
  main()
  reaper.Undo_EndBlock("ReaTrak create stems", -1) 
  
end  

local function btn_click_create_midi()

  function Open_URL(url)
    if not OS then local OS = reaper.GetOS() end
    if OS=="OSX32" or OS=="OSX64" then
      os.execute("start \"\" \"".. url .. "\"")
     else
      os.execute("start ".. url)
    end
  end
  
  function CheckSWS()
    if not reaper.BR_SetItemEdges then
      local retval = reaper.ShowMessageBox("SWS extension is required by this script.\nHowever, it doesn't seem to be present for this REAPER installation.\n\nDo you want to download it now ?", "Warning", 1)
      if retval == 1 then
        Open_URL("http://www.sws-extension.org/")
      end
    else
      return true
    end
  end
  
  
  
  reaper.Main_OnCommand(40421, 0) -- Item: Select all items in track
  
  -- Save item selection
  function SaveSelectedItems (table)
    for i = 0, reaper.CountSelectedMediaItems(0)-1 do
      table[i+1] = reaper.GetSelectedMediaItem(0, i)
    end
  end
  
  
  -- Display a message in the console for debugging
  function Msg(value)
    
    reaper.ShowConsoleMsg(tostring(value) .. "\n")
    
  end
  
  -- SAVE INITIAL VIEW
  function SaveView()
    start_time_view, end_time_view = reaper.BR_GetArrangeView(0)
  end
  
  
  -- RESTORE INITIAL VIEW
  function RestoreView()
    reaper.BR_SetArrangeView(0, start_time_view, end_time_view)
  end
  
  function MultiSplitMediaItem(item, times)
  
    local item_pos = reaper.GetMediaItemInfo_Value(item, "D_POSITION")
    local item_end = reaper.GetMediaItemInfo_Value(item, "D_LENGTH") + item_pos
  
    -- create array then reserve some space in array
    local items = {}
  
    -- add 'item' to 'items' array
    table.insert(items, item)
  
    -- for each time in times array do...
    for i, time in ipairs(times) do
  
      if time > item_end then break end
  
      if time > item_pos and time < item_end then
  
        -- store item so we can split it next time around
        item = reaper.SplitMediaItem(item, time)
  
        -- add resulting item to array
        table.insert(items, item)
  
      end
  
    end
  
    -- return 'items' array
    return items
  
  end
  
  function DeleteItem( item )
  
  
    local track = reaper.GetMediaItemTrack( item )
    reaper.DeleteTrackMediaItem( track, item )
  
  end
  
  function CopyMediaItem(item, track, position)
  
    reaper.SelectAllMediaItems(0 , false)
    reaper.SetMediaItemSelected( item, true)
  
    reaper.SetEditCurPos(position, false, false)
  
    reaper.Main_OnCommand( 40698, 0 ) -- Edit: Copy items
  
    -- Duplicate items track
    reaper.SetOnlyTrackSelected( track )
    reaper.Main_OnCommand( 40914, 0 ) -- Track: Set first selected track as last touched track
    reaper.Main_OnCommand( 40058, 0 ) -- Item: Paste items/tracks
  
    local new_item = reaper.GetSelectedMediaItem(0, 0)
  
    return new_item
  
  end
  
  function GetMIDISources()
  
    local sources = {}
  
    for i, item in ipairs(init_sel_items) do
      local take = reaper.GetActiveTake( item )
      if take and not reaper.TakeIsMIDI( take ) then
        local source = reaper.GetMediaItemTake_Source( take )
        local filename = reaper.GetMediaSourceFileName( source, "" )
        midi_filename = filename:gsub("%.(.+)", '.mid')
        midi_exists = reaper.file_exists( midi_filename )
        if not midi_exists then
          midi_filename = filename:gsub("%.(.+)", '.midi')
          midi_exists = reaper.file_exists( midi_filename )
        end
        if midi_exists then
          if not sources[midi_filename] then sources[midi_filename] = {} end
          table.insert(sources[midi_filename], item)
        end
      end
    end
  
    return sources
   
  end
  --------------------------------------------------------- END OF UTILITIES
  
  -- Move and glue
  
  function move()
    if not midi_exists then goto finish end
    reaper.Main_OnCommand(40001, 0) -- Track: Insert new track
    
    --commandID1 = reaper.NamedCommandLookup("_RS8dae584448854e669ae2c22427811e3fe367addf")
    --reaper.Main_OnCommand(commandID1, 0) -- Script: ReaTrak move selected items to selected track.lua
    move_selected_items()
    reaper.Main_OnCommand(41588, 0) -- Item: Glue items
    
    --commandID3 = reaper.NamedCommandLookup("_RS6f7bce81b208eb305b216b3cc9ba19633cc771db")
    --reaper.Main_OnCommand(commandID3, 0) -- Script: ReaTrak set take name to current reatrak file.lua
      selitem = reaper.GetSelectedMediaItem( 0, 0 )
      
      take = reaper.GetMediaItemTake(selitem, 0)
      
      if take and reaper.TakeIsMIDI( take ) then
      
         takename = reaper.GetTakeName(take)
      
         new_takename = string.match(takename, "- (.*)")
         
         
         if new_takename then
         
           new_takename2 = string.gsub(new_takename, "-glued", ".mid")
           new_takename2 = new_takename2:gsub(".*-", "")
          sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
           retval, namestring = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", "MIDI "..new_takename2, true )
           retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String(take, "P_NAME", new_takename2, 1)
         else
           
           new_takename2 = string.gsub(takename, "-glued", ".mid")
           sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
           retval, namestring = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", "MIDI "..new_takename2, true )
           retval, stringNeedBig = reaper.GetSetMediaItemTakeInfo_String(take, "P_NAME", new_takename2, 1)
         end  
         
         
      end
  ::finish::  
  end
  
  
  
  -- Main function
  function main()
  
    new_items = {}
  
    sources = GetMIDISources()
    
     
    track = reaper.GetSelectedTrack(0,0)
    
    
  
    for midi_filename, items in pairs( sources ) do
  
      local first_item
  
      for i, item in ipairs( items ) do
        reaper.SelectAllMediaItems(0, false)
  
        local take = reaper.GetActiveTake( item )
        local take_name = reaper.GetTakeName( take )
        local source = reaper.GetMediaItemTake_Source( take )
  
        local item_pos = reaper.GetMediaItemInfo_Value( item, "D_POSITION" )
        local item_len = reaper.GetMediaItemInfo_Value( item, "D_LENGTH" )
        local item_end  = item_pos + item_len
        local take_offset = reaper.GetMediaItemTakeInfo_Value( take, "D_STARTOFFS" )
        local take_playrate = reaper.GetMediaItemTakeInfo_Value( take, "D_PLAYRATE" )
  
        if i == 1 then
          reaper.SetEditCurPos(0, false, false) -- Should be item pos
          reaper.InsertMedia( midi_filename, 0 )
          local retval, offs, len, rev = reaper.PCM_Source_GetSectionInfo( source )
  
          local take_off_comp = take_offset * (1/take_playrate)
          local item_source_pos = item_pos - take_off_comp
  
          local new_item = reaper.GetSelectedMediaItem( 0, 0 )
          table.insert(new_items, new_item)
          local new_take = reaper.GetActiveTake( new_item )
  
          reaper.BR_SetItemEdges( new_item, item_source_pos + take_offset / take_playrate , item_source_pos + item_len + take_offset / take_playrate )
          reaper.SetMediaItemTakeInfo_Value( new_take, "D_STARTOFFS", take_offset / take_playrate)
          first_item = new_item
        else
          local new_item = CopyMediaItem(first_item, track, item_pos)
          table.insert(new_items, new_item)
          local new_take = reaper.GetActiveTake( new_item )
          reaper.SetMediaItemTakeInfo_Value( new_take, "D_STARTOFFS", take_offset / take_playrate )
          reaper.BR_SetItemEdges( new_item, item_pos, item_end )
          local retval, string = reaper.GetSetMediaItemTakeInfo_String( new_take, "P_NAME", take_name, true )
        end
      end
    end
  
    for i, item in ipairs( new_items ) do
      reaper.SetMediaItemSelected( item, true )
    end
    
    --move()
  
  end
  
  
  
           
  
  -- INIT
  
  -- See if there is items selected
  count_sel_items = reaper.CountSelectedMediaItems(0)
  if not count_sel_items then goto finish end
  count_sel_tracks = reaper.CountSelectedTracks(0)
  
  sws = CheckSWS()
  
  if not sws then return end
  
  if count_sel_items > 0 and count_sel_tracks > 0 then
  
    reaper.PreventUIRefresh(1)
  
    reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
  
    init_sel_items =  {}
    SaveSelectedItems(init_sel_items)
  
    reaper.ClearConsole()
  
    reaper.Main_OnCommand( 40914, 0 ) -- Track: Set first selected track as last touched track
  
    init_cur_pos = reaper.GetCursorPosition()
  
    SaveView()
  
    main()
    
    reaper.SetEditCurPos(init_cur_pos, false, false)
    
    RestoreView()
  
    reaper.Undo_EndBlock("ReaTrak Midi match same section to audio", -1) -- End of the undo block. Leave it at the bottom of your main function.
  
    reaper.UpdateArrange()
  
    reaper.PreventUIRefresh(-1)
  
  end
  
  move()
::finish::
end

function btn_click_solo_demo()
  
  solo_demo_audio = drum_path_files2[listbox_val2]
  --Msg("solo file "..solo_demo_audio)
  if reaper.file_exists( "C:\\Program Files\\MPC-HC\\mpc-hc64.exe" ) then
   if string.match(solo_demo_audio,"-.*") then
     solo_demo_audio = string.gsub(solo_demo_audio, "-.*", "_Solo.wma")
   else
     solo_demo_audio = string.gsub(solo_demo_audio, "_.*", "_Solo.wma")
   end 
    solo_demo_audio_location = drum_demo_path..solo_demo_audio
    --Msg("solo_demo_audio_location "..solo_demo_audio_location)
    if not reaper.file_exists(solo_demo_audio_location) then
      solo_demo_audio = solo_demo_audio:gsub("%^11-", "^01")
      solo_demo_audio = solo_demo_audio:gsub("%^22-", "^02")
      solo_demo_audio = solo_demo_audio:gsub("%^33-", "^03")
      solo_demo_audio = solo_demo_audio:gsub("%^44-", "^04")
      solo_demo_audio = solo_demo_audio:gsub("%^55-", "^05")
      solo_demo_audio = solo_demo_audio:gsub("%^66-", "^06")
      solo_demo_audio = solo_demo_audio:gsub("%^77-", "^07")
      solo_demo_audio = solo_demo_audio:gsub("%^88-", "^08")
      solo_demo_audio = solo_demo_audio:gsub("%^99-", "^09")
    end  
    --Msg(solo_demo_audio)            
 
    --solo_demo_audio = string.gsub(solo_demo_audio, "-.*", "_Solo.wma")
    solo_demo_audio_location = drum_demo_path..solo_demo_audio
    --Msg("Solo "..solo_demo_audio_location)
    --[[
    if reaper.file_exists(solo_demo_audio_location) == "" then
      solo_demo_audio = string.gsub(solo_demo_audio, "_Solo.wma", "_solo.wma")
      solo_demo_audio_location = drum_demo_path..solo_demo_audio
      Msg("solo "..solo_demo_audio_location)
    end  
    --]]
    if reaper.file_exists(solo_demo_audio_location) then
      reaper.ExecProcess([[cmd.exe /C " cd "C:\\Program Files\\MPC-HC\\" & "mpc-hc64.exe" "]]..solo_demo_audio_location..[[" /minimized"]],-2)
    end   
  end
end

function btn_click_band_demo()

  band_demo_audio = drum_path_files2[listbox_val2]
  --Msg("band file "..band_demo_audio)
  if reaper.file_exists( "C:\\Program Files\\MPC-HC\\mpc-hc64.exe" ) then
    if string.match(band_demo_audio,"-.*") then
      band_demo_audio = string.gsub(band_demo_audio, "-.*", "_Band.wma")
    else
      band_demo_audio = string.gsub(band_demo_audio, "_.*", "_Band.wma")
    end
    band_demo_audio_location = drum_demo_path..band_demo_audio
    if not reaper.file_exists(band_demo_audio_location) then
      band_demo_audio = band_demo_audio:gsub("%^11-", "^01")
      band_demo_audio = band_demo_audio:gsub("%^22-", "^02")
      band_demo_audio = band_demo_audio:gsub("%^33-", "^03")
      band_demo_audio = band_demo_audio:gsub("%^44-", "^04")
      band_demo_audio = band_demo_audio:gsub("%^55-", "^05")
      band_demo_audio = band_demo_audio:gsub("%^66-", "^06")
      band_demo_audio = band_demo_audio:gsub("%^77-", "^07")
      band_demo_audio = band_demo_audio:gsub("%^88-", "^08")
      band_demo_audio = band_demo_audio:gsub("%^99-", "^09")
  end
    --Msg(drum_demo_path..band_demo_audio)
    --Msg(band_demo_audio_location)
    band_demo_audio_location = drum_demo_path..band_demo_audio
    --[[
    if not reaper.file_exists(band_demo_audio_location) then
      band_demo_audio = string.gsub(drum_path_files2[listbox_val2], "-.*", "_band.wma")
      band_demo_audio_location = drum_demo_path..band_demo_audio
      Msg(band_demo_audio_location)
    end  
    --]]
    if reaper.file_exists(band_demo_audio_location) then
      reaper.ExecProcess([[cmd.exe /C " cd "C:\\Program Files\\MPC-HC\\" & "mpc-hc64.exe" "]]..band_demo_audio_location..[[" /minimized"]],-2)
    end   
  end
end

function btn_click_stop_demo()
  
  if reaper.file_exists("C:\\Program Files\\MPC-HC\\mpc-hc64.exe" ) then
    reaper.ExecProcess([[taskkill /f /im mpc-hc64.exe]],-2)
  end
  
end

function btn_click_create_file()
 --filetxt = drum_path_files3[listbox_val2]
 reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items

 local function GetStems()
   col_stem = 1 -- column in StemsInfo.txt
   
   function GetPath(str)
       return str:match("(.*[/\\])")
   end
   
   function GetFilename(path)   
       local start, finish = path:find('[%w%s!-={-|]+[_%.].+')   
       return path:sub(start,#path) 
   end
   
   --function GetFileName(url)
   --  return url:match("^.+/(.+)$")
   --end
   
   function GetFileExtension(url)
     return url:match("^.+(%..+)$")
   end
   
   
   function round(x)
     return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
   end
   
   function create_stem_track(stem_name)
    
     reaper.Main_OnCommand(40062,0) -- Track: Duplicate tracks
     
     sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
     
     reaper.Main_OnCommand(40289,0) -- Item: Unselect (clear selection of) all items
     
     reaper.Main_OnCommand(40421,0) -- Item: Select all items in track
     
     item_count = reaper.CountTrackMediaItems( sel_track )
     
     for i = 0, item_count -1 do
       
       item2 = reaper.GetSelectedMediaItem(0, i)
       take2 = reaper.GetActiveTake(item2)
       item_source = filenamenoext..stem_name..extension
       item_source = string.gsub(item_source, "\\", "\\".."\\")
       --Msg(filenamenoext.."_"..stem_name..extension)
       --Msg(item_source)
       reaper.BR_SetTakeSourceFromFile(take2, item_source, true)
       
     end  
       retval, namestring = reaper.GetSetMediaTrackInfo_String( sel_track, "P_NAME", stem_name, true )
       
       reaper.UpdateArrange() 
       --reaper.Main_OnCommand(40441, 0) -- rebuild peaks for selected items 
       reaper.Main_OnCommand(40047, 0) -- Peaks: Build any missing peaks
       
       
       
   
   end
   
   
   -- Optimization
   local reaper = reaper
   
   -- CSV to Table
   -- http://lua-users.org/wiki/LuaCsv
   function ParseCSVLine (line,sep)
     local res = {}
     local pos = 1
     sep = sep or ','
     while true do
       local c = string.sub(line,pos,pos)
       if (c == "") then break end
       if (c == '"') then
         -- quoted value (ignore separator within)
         local txt = ""
         repeat
           local startp,endp = string.find(line,'^%b""',pos)
           txt = txt..string.sub(line,startp+1,endp-1)
           pos = endp + 1
           c = string.sub(line,pos,pos)
           if (c == '"') then txt = txt..'"' end
           -- check first char AFTER quoted string, if it is another
           -- quoted string without separator, then append it
           -- this is the way to "escape" the quote char in a quote. example:
           --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
         until (c ~= '"')
         table.insert(res,txt)
         assert(c == sep or c == "")
         pos = pos + 1
       else
         -- no quotes used, just look for the first separator
         local startp,endp = string.find(line,sep,pos)
         if (startp) then
           table.insert(res,string.sub(line,pos,startp-1))
           pos = endp + 1
         else
           -- no separator found -> use rest of string and terminate
           table.insert(res,string.sub(line,pos))
           break
         end
       end
     end
     return res
   end
   
   
   -- UTILITIES -------------------------------------------------------------
   
   -- Display a message in the console for debugging
   function Msg(value)
     if console then
       reaper.ShowConsoleMsg(tostring(value) .. "\n")
     end
   end
   
   function ReverseTable(t)
       local reversedTable = {}
       local itemCount = #t
       for k, v in ipairs(t) do
           reversedTable[itemCount + 1 - k] = v
       end
       return reversedTable
   end
   
   --------------------------------------------------------- END OF UTILITIES
   
   function read_lines(filepath)
     --Msg("filepath "..filepath)
     lines = {}
   
     local f = io.input(filepath)
     repeat
   
       s = f:read ("*l") -- read one line
   
       if s then  -- if not end of file (EOF)
         table.insert(lines, ParseCSVLine (s,sep))
       end
   
     until not s  -- until end of file
   
     f:close()
   
   end
   
   -- Main function
   function main()
   
     folder = tostring(filetext):match[[^@?(.*[\/])[^\/]-$]]
   
     for i, line in ipairs( lines ) do
       if i > 2 then
       
         stem_name = line[col_stem]
         --Msg("stem_name "..stem_name)
         create_stem_track(stem_name)    
        
       end    
     end  
     
   end  
     
     
     
    sel_track = reaper.GetSelectedTrack2( 0, 0, 0 )
    
    if not sel_track then 
      item = reaper.GetSelectedMediaItem(0, 0) 
      track = reaper.GetMediaItem_Track(item)
      reaper.SetTrackSelected(track, true)
    
    end
     
    first_item = reaper.GetTrackMediaItem( sel_track, 0 )
    
       if not first_item then goto finish end
       
       take = reaper.GetMediaItemTake( first_item, 0)
       
       source = reaper.GetMediaItemTake_Source(take)
       
       filenamepath = reaper.GetMediaSourceFileName( source )
       
       path = GetPath(filenamepath)
       
       
       --Msg("filenamepath "..filenamepath)
       --Msg("path "..path)
       
       filename = GetFilename(filenamepath)
       --Msg("filename "..filename)
       extension = GetFileExtension(filename)
       --Msg("extension "..extension)
       filenamenoext = string.gsub(filenamepath, extension, "")
       
       filenamenoext = string.gsub(filenamenoext, "Style", "")
       filenamenoext = string.gsub(filenamenoext, "STYLE", "")
       --Msg("filenamenoext "..filenamenoext)
       steminfopath = (path.."StemInfo.txt")
       
       if not reaper.file_exists( steminfopath ) then goto finish end
       --Msg("steminfopath "..steminfopath)
       read_lines(steminfopath)
       filetxt = steminfopath
       main()
     --end 
 ::finish::
 
 end
 
 local function extend_post_fills()
 
   cur_pos = reaper.GetCursorPosition()
   retval, num_markers, num_regions = reaper.CountProjectMarkers( 0 )
   
   for i = 0, num_markers + num_regions do
     retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3( 0, i )
     
     if color == reaper.ColorToNative(17,39,174)|0x1000000 or color == reaper.ColorToNative(11,116,39)|0x1000000 then
       retval, measures_pos, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, pos )
       retval, measures_rgnend, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, rgnend )
       sel_measure_length = measures_rgnend - measures_pos
       
       if sel_measure_length == 1 then
         pos_start, pos_end = reaper.GetSet_LoopTimeRange2( 0, 1, 0, pos, rgnend, 0 )
         reaper.Main_OnCommand(40718,0) -- Item: Select all items on selected tracks in current time selection
         reaper.SetEditCurPos2( 0, rgnend, 0, 0 )
         reaper.Main_OnCommand(41042,0) -- Move edit cursor forward one measure
         reaper.Main_OnCommand(40611,0) -- Item: Set item end to cursor
         commandID1 = reaper.NamedCommandLookup("_SWS_SELNEXTITEM")
         reaper.Main_OnCommand(commandID1, 0) -- SWS: Select next item (across tracks)
         reaper.Main_OnCommand(40511,0) -- Item: Trim items left of cursor
         
       end
     end
   end  
   
   reaper.Main_OnCommand(40635,0) -- Time selection: Remove (unselect) time selection
   reaper.Main_OnCommand(40042,0) -- Transport: Go to start of project
   reaper.SetEditCurPos2( 0, cur_pos, 0, 0 )
 
 end
 
 local function goto_previous_region()
 
   edit_pos = reaper.GetCursorPosition()
   
   play = reaper.GetPlayState()
   if play > 0 then
     pos = reaper.GetPlayPosition()
   else
     pos = edit_pos
   end
   
   count_markers_regions, count_markersOut, count_regionsOut = reaper.CountProjectMarkers(0)
   
   i=1
   repeat
     iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,count_markers_regions-i)
     if iRetval >= 1 then
       if bIsrgnOut == true and iPosOut < pos then
         -- ACTION ON REGIONS HERE
         reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
         break
       end
       i = i+1
     end
   until iRetval == 0
 
 end
 
 local function goto_next_region()
 
   edit_pos = reaper.GetCursorPosition()
   
   play = reaper.GetPlayState()
   if play > 0 then
     pos = reaper.GetPlayPosition()
   else
     pos = edit_pos
   end
   
   i=0
   repeat
     iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,i)
     if iRetval >= 1 then
       if bIsrgnOut == true and iPosOut > pos then --bIsrgnOut == true for region bIsrgnOut == false for marker
         -- ACTION ON REGIONS HERE
         reaper.SetEditCurPos(iPosOut,true,true) -- moveview and seekplay
         break
       end
       i = i+1
     end
   until iRetval == 0
 
 end
 
 local function export_regions()
 
   -- Format Seconds
   function Format(number)
     str = reaper.format_timestr_pos(number, "", 5)
     return str
   end
   
   
   
   --------------------------------------------------------
   -- PATHS
   -- -----
   
   -- Get Path from file name
   function GetPath(str,sep)
       return str:match("(.*"..sep..")")
   end
   
   
   -- Check if project has been saved
   function IsProjectSaved()
     -- OS BASED SEPARATOR
     if reaper.GetOS() == "Win32" or reaper.GetOS() == "Win64" then
       -- user_folder = buf --"C:\\Users\\[username]" -- need to be test
       separator = "\\"
     else
       -- user_folder = "/USERS/[username]" -- Mac OS. Not tested on Linux.
       separator = "/"
     end
   
     --path = reaper.GetProjectPath("") -- E:\Bureau\Projet\Audio
     --path = path:gsub("Audio", "") -- E:\Bureau\Projet\
   
     retval, project_path_name = reaper.EnumProjects(-1, "")
     if project_path_name ~= "" then
       
       dir = GetPath(project_path_name, separator)
       --msg(name)
       name = string.sub(project_path_name, string.len(dir) + 1)
       name = string.sub(name, 1, -5)
   
       name = name:gsub(dir, "")
       --file = dir .. "HTML" .. separator .. name .. " - Items List.html"
       file = dir .. name .. " - ReaTrak Regions List.txt"
       --msg(name)
       project_saved = true
       return project_saved
     else
       display = reaper.ShowMessageBox("You need to save the project to execute this script.", "File Export", 1)
   
       if display == 1 then
   
         reaper.Main_OnCommand(40022, 0) -- SAVE AS PROJECT
   
         return IsProjectSaved()
   
       end
     end
   end
   
   
   ------------------------------------------------------------------
   -- COLOR FUNCTIONS
   -- ---------------
   function rgbToHex(r, g, b)
       return string.format("#%0.2X%0.2X%0.2X", r, g, b)
   end
   
   
   --------------------------------------------------------------
   -- CREATE FILE
   -- -----------
   
   -- New HTML Line
   function export(f, variable)
     f:write(variable)
     f:write("\n")
   end
   
   
   -- Create File
   function create(f)
     -- CREATE THE FILE
   
     local f = io.open(file, "w")
     
     export(f, "#  Name  Start  End  Length  Color")
     
     i=0
     repeat
       iRetval, bIsrgnOut, iPosOut, iRgnendOut, name, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,i)
       if iRetval >= 1 then
      local t, duration
      if bIsrgnOut then
        t = "R"
        duration = iRgnendOut - iPosOut
      else 
        t = "M"
        duration = 0
        iRgnendOut = iPosOut
      end
      
      local color = 0
      if iColorOur > 0 then
        r,g,b = reaper.ColorFromNative(iColorOur)
        color = rgbToHex(r, g, b)
      end
        -- [start time HH:MM:SS.F] [end time HH:MM:SS.F] [name]
        line = t .. iMarkrgnindexnumberOut .. "\t\"" .. name .. "\"\t" .. iPosOut .. "\t" .. iRgnendOut .. "\t" .. duration .. "\t" .. color
        export(f, line)
      end
      i = i+1
     until iRetval == 0
   
   
 
     -- CLOSE FILE
     f:close() -- never forget to close the file
   
     --Msg("Regions Lists exported to:\n" .. file .."\n")
   
   end
   
   
   
   ----------------------------------------------------------------
   -- MAIN FUNCTION
   -- -------------
   
   function main() -- local (i, j, item, take, track)
   
     local f = io.open(file, "w")
   
     -- HTML FOLDER EXIST
     if f ~= nil then
       create(f)
     end
   
   end -- ENDFUNCTION MAIN
   
   
   ----------------------------------------------------------------------
   -- RUN
   -- ---
   
   -- Check if there is selected Items
   retval, count_markers, count_regions = reaper.CountProjectMarkers(0)
   
   if count_regions > 0 then
   
     project_saved = IsProjectSaved() -- See if Project has been save and determine file paths
     if project_saved then
       main() -- Execute your main function
     end
   
   else
     --Msg("No regions in the project.")
   end -- ENDIF Item in project
 
 end
 
 local function import_regions()
   
   --Delete existing Regions first
   commandID1 = reaper.NamedCommandLookup("_SWSMARKERLIST10")
   reaper.Main_OnCommand(commandID1, 0) -- SWS: Delete all regions
   
   -- Format Seconds
   function Format(number)
     str = reaper.format_timestr_pos(number, "", 5)
     return str
   end
   
   -- Get Path from file name
   function GetPath(str,sep)
       return str:match("(.*"..sep..")")
   end
   
   -- USER CONFIG AREA -----------------------------------------------------------
   -- Duplicate and Rename the script if you want to modify this.
   -- Else, a script update will erase your mods.
   
   console = true -- true/false: display debug messages in the console
   sep = "\t" -- default sep
   
   col_pos = 3 -- Position column index in the CSV
   col_pos_end = 4 -- Length column index in the CS
   col_len = 5 -- Length column index in the CSV
   col_name = 2 -- Name column index in the CSV
   col_color = 6
   
   ------------------------------------------------------- END OF USER CONFIG AREA
   
   function ColorHexToInt(hex)
     hex = hex:gsub("#", "")
     local R = tonumber("0x"..hex:sub(1,2))
     local G = tonumber("0x"..hex:sub(3,4))
     local B = tonumber("0x"..hex:sub(5,6))
     return reaper.ColorToNative(R, G, B)
   end
   
   -- Optimization
   local reaper = reaper
   
   -- CSV to Table
   -- http://lua-users.org/wiki/LuaCsv
   function ParseCSVLine (line,sep)
     local res = {}
     local pos = 1
     sep = sep or ','
     while true do
       local c = string.sub(line,pos,pos)
       if (c == "") then break end
       if (c == '"') then
         -- quoted value (ignore separator within)
         local txt = ""
         repeat
           local startp,endp = string.find(line,'^%b""',pos)
           txt = txt..string.sub(line,startp+1,endp-1)
           pos = endp + 1
           c = string.sub(line,pos,pos)
           if (c == '"') then txt = txt..'"' end
           -- check first char AFTER quoted string, if it is another
           -- quoted string without separator, then append it
           -- this is the way to "escape" the quote char in a quote. example:
           --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
         until (c ~= '"')
         table.insert(res,txt)
         assert(c == sep or c == "")
         pos = pos + 1
       else
         -- no quotes used, just look for the first separator
         local startp,endp = string.find(line,sep,pos)
         if (startp) then
           table.insert(res,string.sub(line,pos,startp-1))
           pos = endp + 1
         else
           -- no separator found -> use rest of string and terminate
           table.insert(res,string.sub(line,pos))
           break
         end
       end
     end
     return res
   end
   
   
   -- UTILITIES -------------------------------------------------------------
   
  
   function ReverseTable(t)
       local reversedTable = {}
       local itemCount = #t
       for k, v in ipairs(t) do
           reversedTable[itemCount + 1 - k] = v
       end
       return reversedTable
   end
   
   --------------------------------------------------------- END OF UTILITIES
   
   function read_lines(filepath)
   
     lines = {}
   
     local f = io.input(filepath)
     repeat
   
       s = f:read ("*l") -- read one line
   
       if s then  -- if not end of file (EOF)
         table.insert(lines, ParseCSVLine (s,sep))
       end
   
     until not s  -- until end of file
   
     f:close()
   
   end
   
   -- Main function
   function main()
   
     folder = filetxt:match[[^@?(.*[\/])[^\/]-$]]
   
     for i, line in ipairs( lines ) do
       if i > 1 then
   
         -- Name Variables
         local pos = tonumber(line[col_pos])
         local pos_end = tonumber(line[col_pos_end])
         local len =  tonumber( line[col_len] )
         local name = line[col_name]
         local color = 0
         if line[col_color] ~= "0" then
           color = ColorHexToInt(line[col_color])|0x1000000
         end
         
         local is_region = true
         
         if pos_end == pos then
           is_region = false
         end
         
         if pos and pos_end and name and color then
           reaper.AddProjectMarker2( 0, is_region, pos, pos_end, name, -1, color )
         end
   
       end
     end
   
   end
   
   -- INIT
   
     -- OS BASED SEPARATOR
     if reaper.GetOS() == "Win32" or reaper.GetOS() == "Win64" then
       -- user_folder = buf --"C:\\Users\\[username]" -- need to be test
       separator = "\\"
     else
       -- user_folder = "/USERS/[username]" -- Mac OS. Not tested on Linux.
       separator = "/"
     end
   
     retval, project_path_name = reaper.EnumProjects(-1, "")
     
     --Msg("project_path_name ".. project_path_name)
     --if project_path_name ~= "" then
       
       dir = GetPath(project_path_name, separator)
       --msg(name)
       name = string.sub(project_path_name, string.len(dir) + 1)
       name = string.sub(name, 1, -5)
   
       name = name:gsub(dir, "")
       --file = dir .. "HTML" .. separator .. name .. " - Items List.html"
       filetxt = dir .. name .. " - ReaTrak Regions List.txt"
   
   
   --[[
   retval, filetxt = reaper.GetUserFileNameForRead("", "Import markers and regions", "txt")
   
   if retval then
   --]]
     reaper.PreventUIRefresh(1)
   
     reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
     
     --reaper.ClearConsole()
   
     read_lines(filetxt)
     
     -- reaper.Main_OnCommand( reaper.NamedCommandLookup( "_SWSMARKERLIST10" ), -1) -- SWS: Delete all regions
   
     main()
 
 end
 
 
 local function split_region_cursor()
 
      --commandID4 = reaper.NamedCommandLookup("_RS3374194533e692527a47ca4ede0688a20fd691fd")
      --reaper.Main_OnCommand(commandID4, 0) -- Script: ReaTrak split regions at tempo markers.lua
   
   tempo_markers_count = reaper.CountTempoTimeSigMarkers(0)
   
   for i = 0, tempo_markers_count - 1 do
      retval, timepos, measurepos, beatpos, bpm1, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker(0, i)
      
      reaper.SetEditCurPos(timepos, 0, 0)
   
      retval, num_markers, num_regionsOut = reaper.CountProjectMarkers(0)
      
      desired_region_id = num_regionsOut
      
      time = reaper.GetCursorPosition()
      
      markeridx, regionidx = reaper.GetLastMarkerAndCurRegion(0, time)
      
      retval, isrgn, pos, rgnend, name, markrgnindexnumber, color = reaper.EnumProjectMarkers3(0, regionidx)
      
      if time == pos then goto finish end
      
      if time < rgnend then
         
         reaper.SetProjectMarker3( 0, markrgnindexnumber, 1, pos, time, name, color )
      
         reaper.AddProjectMarker2(0, 1, time, rgnend, name, desired_region_id, color)
      end
      
      ::finish::
      
   end  
 
 end
 
 function get_tempo_cursor()
 
          current_cursor_pos2 = reaper.GetCursorPosition()
          timesig_num, timesig_denom, current_tempo = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos2)
          return
 
 end
 
 
 function get_tempo_markers()
 
         --Msg("function get_tempo_markers")
          bpm2 = bpm
          --region_length1 = region_length
          cur_pos = reaper.GetCursorPosition()
          tempo_markers_count = reaper.CountTempoTimeSigMarkers(0)
          for i = 0, tempo_markers_count - 1 do
 
              retval, timepos, measurepos, beatpos, bpm1, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker(0, i)
              --Msg("Main bpm1 ".. bpm1)
              --Msg("rgnpos,rgnend ".. rgnpos .. rgnend)
              --Msg("rgnpos ".. rgnpos)
              --Msg("timepos ".. timepos)
              --if beats_per_measure ~= timesig_num then break end
 
              --If tempo change occurs at region start
 
              --if timepos == cur_pos then bpm2 = bpm1 return end
 
              if timepos == rgnpos then
 
                 --region_length1 = region_length
 
                 --set_position = rgnpos
 
                 bpm2 = bpm1
                 --return (bpm2) end
                 --Msg("bpm2======================= ".. bpm2)
 
                 return
 
              end
 
              --If tempo change occurs in region
 
              if timepos > rgnpos and timepos < rgnend then
 
                 --region_length1 = (timepos - rgnpos)
 
                 --set_position = timepos
 
                 bpm2 = bpm1
 
                 --Msg("bpm1 ".. bpm1)
 
                 return
 
                 --break
 
              end
 
 
          end
 end
 
 --if current_drum == 1 then goto end_split end
 console = true -- true/false: display debug messages in the console
 sep = "," -- default sep
 --Msg("realdrums ext "..realdrums_extension1)
 --Msg("user_offset1 "..user_offset1)
 --[[
 if realdrums_extension == "xxx" then
   realdrums_extension = "wma"
   user_offset = "0"
   --Msg("realdrums_extension "..realdrums_extension.." user_offset "..user_offset)
 end  
 --]]
 --realdrums_extension1 = "wma"
 --user_offset1 = "0" 
 --input1 = "50" 
 --input2 = "10"
-- Msg("user_offset1 CURRENT "..user_offset)
 
 --retval_inputs, retvals_csv = reaper.GetUserInputs( "Set inputs", 2, "Input 1,Input 2", input1 .. "," .. input2)
 --else realdrums_extension = realdrums_extension1 users_offset = users_offset1 end --..realdrums_extension1:gsub(".","")..[[]] 
 --Msg(realdrums_extension1) 
 --if user_offset ~= "0" then user_offset = "0" Msg(user_offset) end
-- Msg("realdrums_extension "..realdrums_extension)
 realdrums_extension = realdrums_extension:sub(-3)
 
 --Msg("realdrums_extension -. "..realdrums_extension)
 retval_inputs, retvals_csv = reaper.GetUserInputs( "Select Drums Extension & Offset", 2, "wav wma m4a aif mp4 video,Offset (if any + - sec) eg. 5 -5", realdrums_extension .. "," .. user_offset)
 if not retval_inputs then return end --goto finish2 end
 realdrums_extension, user_offset = retvals_csv:match("([^,]+),([^,]+)")
 
 realdrums_extension = "."..realdrums_extension
 
 reaper.BR_Win32_WritePrivateProfileString("reaper", "biab_drums_ext", realdrums_extension, inipath)
                          
 --realdrums_extension1 = realdrums_extension
 --user_offset1 = user_offset
 --Msg("user_offset1 SET "..user_offset)
 
     --user_offset = tonumber(user_offset)
     -- if not user_offset then user_offset = 0 end
 
     --Msg("File type "..realdrums_extension)
 
          tempo_markers_count = reaper.CountTempoTimeSigMarkers(0)
          if tempo_markers_count > 0 then
             --retval_split,input_yes  = reaper.GetUserInputs("Region Split to Tempo Map", 1, "Split Regions @ Tempo changes ?", "yes")
             --commandID1 = reaper.NamedCommandLookup("_RS3628f83c9f311bd67b97be26bb47f9d76c5cbaf9")
             --reaper.Main_OnCommand(commandID1, 0) -- Script: ReaTrak Export regions as file.lua
             export_regions()
 
             split_region_cursor()
             regions_saved = 1
             --if not retval_split then goto end_split end
 
             --if input_yes == "yes" then
 
 
                --for i = 0, tempo_markers_count - 1 do
                    --retval, timepos, measurepos, beatpos, bpm1, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker(0, i)
 
                    --reaper.SetEditCurPos(timepos, 0, 0)
                    --split_region_cursor()
                --end
 
             --end
       end
 
 ::end_split::
 
 
 
 commandID3 = reaper.NamedCommandLookup("_SWSMARKERLIST8")
 reaper.Main_OnCommand(commandID3, 0) -- SWS: Renumber region IDs
 --Msg("Regions Renumbered")
 
 --(1)pattern,(2)type,(3)A verse B chorus,(4)weight,(5)mask,(6)duration,(7)bar
 --(1)shot,(2)0 shot 1 hold,(3)bar,(4)ticks,(5)duration ticks,weight,volume
 
 col_pos = 7 -- Position column index in the CSV
 col_pos_end = 4 -- Length column index in the CS
 col_len = 6 -- Length column index in the CSV
 col_name = 2 -- Name column index in the CSV
 col_color = 3
 col_pattern = 1
 col_ticks = 5
 col_shot = 3
 
 unit = 4
 bpm, beat_per_measure = reaper.GetProjectTimeSignature2(0)
 
 --Msg("Project BPM ".. bpm)
 wavename = ""
 ------------------------------------------------------- END OF USER CONFIG AREA
 
 function ColorHexToInt(hex)
   hex = hex:gsub("#", "")
   local R = tonumber("0x"..hex:sub(1,2))
   local G = tonumber("0x"..hex:sub(3,4))
   local B = tonumber("0x"..hex:sub(5,6))
   return reaper.ColorToNative(R, G, B)
 end
 
 -- Optimization
 local reaper = reaper
 
 
 
 
 -- CSV to Table
 -- http://lua-users.org/wiki/LuaCsv
 function ParseCSVLine (line,sep)
   local line = string.gsub(line, "{.*}", "") -- remove { } and text between them
   local line = string.gsub(line, ";.*", "") -- remove ; and text after it
   local line = string.gsub(line, "pattern,PreFill.*", "") -- remove pattern,PreFill line
 
 
 
    --if line == string.match(line,"wavename=.*") then wavename = line end
 
    --if line == string.match(line,"TimeSig=.*") then timesig = line end
 
    --if line == string.match(line,"Offset=.*") then offset = line end
 
   local res = {}
   local pos = 1
   sep = sep or ','
   while true do
     local c = string.sub(line,pos,pos)
     if (c == "") then break end
     if (c == '"') then
       -- quoted value (ignore separator within)
       local txt = ""
       repeat
         local startp,endp = string.find(line,'^%b""',pos)
         txt = txt..string.sub(line,startp+1,endp-1)
         pos = endp + 1
         c = string.sub(line,pos,pos)
         if (c == '"') then txt = txt..'"' end
         -- check first char AFTER quoted string, if it is another
         -- quoted string without separator, then append it
         -- this is the way to "escape" the quote char in a quote. example:
         --   value1,"blub""blip""boing",value3  will result in blub"blip"boing  for the middle
       until (c ~= '"')
       table.insert(res,txt)
       assert(c == sep or c == "")
       pos = pos + 3
     else
       -- no quotes used, just look for the first separator
       local startp,endp = string.find(line,sep,pos)
       if (startp) then
         table.insert(res,string.sub(line,pos,startp-1))
         pos = endp + 1
       else
         -- no separator found -> use rest of string and terminate
         table.insert(res,string.sub(line,pos))
         break
       end
     end
   end
   return res
 
 end
 
 -- UTILITIES -------------------------------------------------------------
 
 -- Display a message in the console for debugging
 function Msg(value)
   reaper.ShowConsoleMsg(tostring(value) .. "\n")
   
 end
 
 function ReverseTable(t)
     local reversedTable = {}
     local itemCount = #t
     for k, v in ipairs(t) do
         reversedTable[itemCount + 1 - k] = v
     end
     return reversedTable
 end
 
 --------------------------------------------------------- END OF UTILITIES
 

 function read_lines(filepath)
   --Msg("filepath filetxt "..filepath)
   lines = {}
 
   local f = io.input(filepath) --io.input(filepath)
   repeat
 
     s = f:read ("*l") -- read one line
 
     if s then  -- if not end of file (EOF)
       table.insert(lines, ParseCSVLine (s,sep))
       --Msg("line "..s)
     end
 
   until not s  -- until end of file
 
   f:close()
 
 end
 
 function get_wavename() -- NOT USED
   --filetxt = drum_path_files3[listbox_val2]
 --function get_lines(filename)
     local lines = {}
     -- io.lines returns an iterator, so we need to manually unpack it into an array
     for line in io.lines(filetxt) do --:gsub("\"", "")) do
         lines[#lines+1] = line
     --end
 
 
     if line == string.match(line,"wavename=.*") then wavename = line Msg("CSV2 wavename ".. wavename) end
 
     if line == string.match(line,"TimeSig=.*") then timesig = line Msg("CSV2 TimeSig ".. timesig) end
 
     if line == string.match(line,"Offset=.*")
        then offset = line Msg("CSV2 OffsetCap0 ".. offset) offsetCap = 0 end
 
     if line == string.match(line,"OFFSET=.*")
        then offset = line Msg("CSV2 OffsetCap1 ".. offset) offsetCap = 1 end
 
     return lines
     --end
     --local key, value = line:match("^([%w_]+)%s-=%s-(.+)$")
 
 
    end
 
 end
 
 
 function get_drum_values()
    --Msg("get_drum_values() "..filetxt:gsub("\"", ""))
    --filetxt:gsub("\"", "")
    --filetxt = drum_path_files3[listbox_val2]
    vars = {}
    for line in io.lines(filetxt) do --:gsub("\"", "")) do
    --for i, v in pairs(lines) do
    
     --if v[1] then
        --Msg("TABLE "..v[1])
      
      line = string.gsub(line, ";.*", "") -- remove ; and text after it
      var, val = line:match('^([^=]+)=(.*)')
 
      --if var then Msg("".. var .."=".. val) end
      if var == "wavename" then wavename1 = val end --Msg("wavename# ".. wavename) end
      if var == "TimeSig" then timesig = val end --Msg("TimeSig# ".. timesig) end
      if var == "Offset" then rd_offset = val end
      if var == "OFFSET" then rd_offset = val end
     --end
 
      if not line then end
    end
 
    --Msg("wavename1 "..wavename1) 
      --Msg("VARSOffset=".. vars.Offset)
    --Msg("wavename=".. vars.wavename)
    -- vars.wavename, vars.TimeSig, vars.Offset
 
 end
 
 
 -- Main function
 function drum_pattern()
   --filetxt = drum_path_files3[listbox_val2]
   org_cur_pos = reaper.GetCursorPosition()
 
 
   get_drum_values()
   --filetxt = drum_path_files3[listbox_val2]
   --Gets wavename from CSV to Table function ParseCSVLine adds the chosen file type extension
   --wavename1 = string.gsub(wavename, "wavename=", "")
   wavename2 = string.gsub(wavename1, ".wav", realdrums_extension)
   --Msg("Wavename2 ".. wavename2)
 
   --Gets BPM from wavename
   --Msg("Filename to get BPM from ".. wavename2)
   bb_bpm = string.match(wavename2, "%_+(%S+)%_")
   --Msg("BPM ".. bb_bpm)
   --Msg("RD Offset ticks ".. rd_offset)
   line_pos = string.find(bb_bpm, "0")
   if line_pos == 0 then bb_bpm1 = string.gsub(bb_bpm, "0","",1) end
 
 
 
 os_type = reaper.GetOS() -- "Mac OSX" -- "Win64" --
 --slash = string.match(os_type, "Win") and "\\" or "/"
 
 if os_type ~= "Win32" and os_type ~= "Win64" then
 --Mac OS
    --filetxt = drum_path_files3[listbox_val2]
    dir1 = string.gsub(filetxt, "/[^/]*$", "")
    dir = dir1 .."/"
    txt_filename1 = string.match(filetxt, "/[^/]*$")
    txt_filename = string.gsub(txt_filename1, "/", "")
    txt_filename_folder = string.gsub(wavename2, "_.*", "") -- remove _ and text after it
    blank_ext = string.gsub(txt_filename, ".txt", "")
    dir_back1 = string.gsub(dir1,"(.*)/.*$","%1")
    dir_back2 = string.gsub(dir_back1,"(.*)/.*$","%1")
    dir_back = dir_back1 .."/"
    txt_filename_folder2 = txt_filename_folder .."/"
 
 
 else
 --Win OS
    --filetxt = drum_path_files3[listbox_val2]
    
    dir1 = string.gsub(filetxt, "\\[^\\]*$", "")
    --Msg("Dir "..dir1)
    dir = dir1 .."\\"
    txt_filename1 = string.match(filetxt, "\\[^\\]*$")
    txt_filename = string.gsub(txt_filename1, "\\", "")
    txt_filename_folder = string.gsub(wavename2, "_.*", "") -- remove _ and text after it
    blank_ext = string.gsub(txt_filename, ".txt", "")
    dir_back1 = string.gsub(dir1,"(.*)\\.*$","%1")
    dir_back2 = string.gsub(dir_back1,"(.*)\\.*$","%1")
    dir_back = dir_back1 .."\\"
    txt_filename_folder2 = txt_filename_folder .."\\"
    --Msg("dir "..dir) 
    --Msg("dir_back1 "..dir_back1) 
    --Msg("dir_back2 "..dir_back2) 
    --Msg("dir_back "..dir_back) 
    
 end
 
   match = 0
   pass = 0
   loop_number = 0
   old_region_number2 = 0
   previous_region = 0
   pre_cursor_pos = 0
   --dir and dir_back, if chosen file type is not found in current dir
   --it will look back a director
   --the "\\" "/" are worked out in os_type = reaper.GetOS() below
   open_file = dir .. wavename2
   open_file_back = dir_back .. wavename2
   open_file_back2 = dir_back .. txt_filename_folder2 .. wavename2
   --Msg("open_file ".. open_file)
   --Msg("open_file_back ".. open_file_back)
   --Msg("open_file_back2 ".. open_file_back2)
   
   --open_file = ("\""..open_file.."\"")
   
   open_file = string.gsub(open_file, '^%s*(.-)%s*$', '%1')
   open_file_back = string.gsub(open_file_back, '^%s*(.-)%s*$', '%1')
   open_file_back2 = string.gsub(open_file_back2, '^%s*(.-)%s*$', '%1')
   --Msg("open_file ".. open_file)
   --Msg("open_file_back ".. open_file_back)
   --Msg("open_file_back2 ".. open_file_back2)   
   
   --open_file_back = ("\""..open_file_back.."\"")
   
   --Msg("open_file_back ".. open_file_back)
   
   if reaper.file_exists(open_file) then file_source = open_file end
   
   if reaper.file_exists(open_file_back) then file_source = open_file_back end
   
   if reaper.file_exists(open_file_back2) then file_source = open_file_back2 end
   --Msg("open_file_back2 ".. open_file_back2)
   --Msg("Source file found in ".. file_source)
   
   --file_source = "/Applications/Band-in-a-Box/Drums/RockHardModernEv8^/RockHardModernEv8^_120_Style.m4a"
 
    --Msg("dir ".. dir)
    --Msg("txt_filename_folder ".. txt_filename_folder)
    --Msg("txt_filename_folder2 ".. txt_filename_folder2)
    --Msg("dir_back1 ".. dir_back1)
    --Msg("dir_back2 ".. dir_back2)
    --Msg("dir_back ".. dir_back)
    --Msg("wavename2 ".. wavename2)
 
   --Msg("Drum TimeSig ".. timesig)
   --Gets drums TimeSig and Offset from the text file in the CSV to Table
   if timesig == "3" and beat_per_measure == 4.0 then
      Info1 = [[ This Drum is "3" beats per measure]]
      reaper.MB(Info1, "Drum Beats Per Measure", 0)
   end
 
   if timesig == "4" and beat_per_measure == 3.0 then
      Info1 = [[ This Drum is "4" beats per measure]]
      reaper.MB(Info1, "Drum Beats Per Measure", 0)
 
   end
 
 
   --if offsetCap == 0 then rd_offset = string.gsub(offset, "Offset=", "") end
   --if offsetCap == 1 then rd_offset = string.gsub(offset, "OFFSET=", "") end
 
 
     --Msg("RD offset  value " .. rd_offset)
 
   --copies the source file location into the system clipboard
   --reaper.CF_SetClipboard(file_source)  
   --Msg("file_source ".. file_source)
   --to confirm it's in the clipboard Msg("buf".. buf)
   --buf = reaper.CF_GetClipboard(buf)
 
   --commandID1 = reaper.NamedCommandLookup("_XENAKIOS_INSERTMEDIAFROMCLIPBOARD")
   --reaper.Main_OnCommand(commandID1, 0) -- Xenakios/SWS: Insert media file from clipboard
   --Msg("file_source ".. file_source)
   reaper.InsertMedia( file_source, 0 )
 
   reaper.Main_OnCommand(41173, 0) -- Item navigation: Move cursor to start of items
 
   Info = [[ The First time let the peaks draw then click Ok]]
   reaper.MB(Info, "Creating reapeak file", 0)
 
   imported_drums = reaper.GetSelectedMediaItem(0, 0)
   take = reaper.GetActiveTake( imported_drums )
 
   --bpm = project tempo / drums tempo
   playrate = (bpm / bb_bpm)
   reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", playrate )
 
   reaper.Main_OnCommand(40699, 0) -- Edit: Cut items
 
   region_count , num_markersOut , num_regionsOut = reaper.CountProjectMarkers(0)
 
   region_number = 0
 
   start_time, end_time = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
   _, first_region = reaper.GetLastMarkerAndCurRegion( 0, start_time )
   _, last_region = reaper.GetLastMarkerAndCurRegion(0, end_time)
   if last_region == -1 then last_region = num_regionsOut end 
   
   --Msg("last_region ".. last_region)
   --region_number = first_region
 
   if start_time == end_time then
      region_number = 0
      --Msg("No Selection ")
   end
 
   if start_time ~= end_time then
      --Msg("Selection ")
      num_regionsOut = last_region
      region_number = first_region
      reaper.SetEditCurPos(start_time, 0, 0)
   end
 
 
   
 
 
   --Msg("start_time ".. start_time .." End time ".. end_time)
 
   --Msg("first_region ".. first_region)
   --Msg("region_number ".. region_number)
 
   --Msg("regionidx ".. regionidx)
 
 
   loop_stuck = 0
   --region_number = first_region
 
   folder = filetxt:match[[^@?(.*[\/])[^\/]-$]]
 
   goto enum_regions
 
   ::enum_regions::
   
   
   previous_region = region_number
   --Msg("region_number ".. region_number .." last_region ".. last_region)
 
   if start_time ~= end_time and region_number == last_region then goto finish end
 
 
   --if region_number == last_region -1 then goto finish end
 
   --reaper.SetEditCurPos(rgnpos, 0, 0)
 
   --Msg("enum_regions")
   --Msg("==================")
   --Msg("region_number ".. region_number)
   --Msg("last_region " .. last_region)
   --region_count , num_markersOut , num_regionsOut = reaper.CountProjectMarkers(0)
 
   retval, isrgn, rgnpos, rgnend, rgnname, markrgnindexnumber, rgncolor = reaper.EnumProjectMarkers3(0, region_number)
   
   tempo_markers_count = reaper.CountTempoTimeSigMarkers(0)
   --if tempo_markers_count == 0 then
      consecutive = 0
   --========================================================================
   -- JOIN CONSECUTIVE COLOR REGIONS
 
       count_markers_regions, count_markersOut, count_regionsOut = reaper.CountProjectMarkers(0)
       
       if region_number ~= count_regionsOut -1 and region_number == old_region_number2 then region_number = region_number +1 end
       
      
       --if region_number == old_region_number2 then region_number = region_number +1 end
      
       --Msg("region_number ".. region_number .. " old_region_number2 ".. old_region_number2)
       
       --Msg("===========================")
       
       --Msg("region_number ".. region_number .." count_regionsOut "..count_regionsOut)
       
       current_cursor_pos5 = reaper.GetCursorPosition()
 
       timesig_num, timesig_denom, current_tempo = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos5)
 
       count_markers_regions, count_markersOut, count_regionsOut = reaper.CountProjectMarkers(0)
 
       for i = region_number, count_regionsOut do
         
         iRetval, bIsrgnOut, iPosOut, iRgnendOut, sNameOut, iMarkrgnindexnumberOut, iColorOur = reaper.EnumProjectMarkers3(0,i)
 
         reaper.SetEditCurPos(iPosOut, 0, 0)
 
         current_cursor_pos3 = reaper.GetCursorPosition()
 
         timesig_num, timesig_denom, tempo_change = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos3)
 
 
           --Msg("current_tempo ".. current_tempo .." tempo_change "..tempo_change)
           
           
           if tempo_change ~= current_tempo then -- OR TEMPO CHANGE and TEMPO CHANGES OCCUR ON SPLIT REGIONS
              rgnend = iPosOut
              --consecutive = 1
 
 
              break
           end
 
           if iColorOur == rgncolor then
              --i = i +1
              region_number = region_number +1
           end
 
           if region_number == last_region then
              rgnend = end_time
              
              break
 
           end
 
           if iColorOur ~= rgncolor then
              rgnend = iPosOut
              consecutive = 1
 
              break
           end
         
         
           if i == count_regionsOut -1 then break end        
         
         --end
 
       current_cursor_pos4 = reaper.GetCursorPosition()
 
       timesig_num, timesig_denom, current_tempo = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos4)
 
   --if consecutive == 0 then region_number = region_number -1 end
 --==========================================================================
   end
       
       
       old_region_number1 = region_number
       
       old_region_number2 = old_region_number1
       
       region_number = region_number -1
 
 
   --Msg("region_number ".. region_number)
   --Msg("rgnpos ".. rgnpos)
   --Msg("rgnname ".. rgnname)
 
   --Info = [[ Continue Ok]]
   --reaper.MB(Info, "PAUSE", 0)
 
   --when source file is pasted it will be at current region
   reaper.SetEditCurPos(rgnpos, 0, 0)
 
   goto start_match
 ::start_match::
   --i = 2
   --Msg("loop_stuck "..loop_stuck) 

   if loop_stuck > 200 then 
     loop_stuck = 0 
     region_number = region_number +1
     goto enum_regions 
   end --goto finish end
   
   if region_number -1 == num_regionsOut then goto finish end
   
   for i, line in ipairs( lines ) do
 
 
     if line[col_pattern] == "Shot" or line[col_pattern] == "pattern" then --line[col_name] == "Shot" then --
 
 
      if i > 1 then
 
       -- Name Variables
       local pos = line[col_pos]
       --local pos_end = tonumber(line[col_pos] +1) --tonumber(line[col_pos_end])
       local len =  line[col_len]
       local name = line[col_name]
       local color = 0
       local dura_ticks = line[col_ticks]
       local ticks = line[col_pos_end]
       local shot_bar = line[col_shot]
       --Msg("Line Name ".. name)
 --(1)pattern,(2)type,(3)A verse B chorus,(4)weight,(5)mask,(6)duration,(7)bar
 --(1)shot,(2)0 shot 1 hold,(3)bar,(4)ticks,(5)duration ticks,weight,volume
 
 --col_pos = 7 -- Position column index in the CSV
 --col_pos_end = 4 -- Length column index in the CS
 --col_len = 6 -- Length column index in the CSV
 --col_name = 2 -- Name column index in the CSV
 --col_color = 3
 --col_pattern = 1
 --col_ticks = 5
 
 
       if line[col_name] == "Count-in" then
         color = ColorHexToInt("#FF80C0")|0x1000000
         --duration = 2
         part = "Count-in"
       end
       if (line[col_color] == "A" or line[col_color] == "a") and line[col_name] == "PostFill" then
         color = ColorHexToInt("#1127AE")|0x1000000
         --duration = 1
         part = "Verse PostFill"
       end
       if (line[col_color] == "A" or line[col_color] == "a") and line[col_name] == "Normal" then
         color = ColorHexToInt("#3776EB")|0x1000000
         --duration = 1
         part = "Verse"
       end
       if (line[col_color] == "A" or line[col_color] == "a") and line[col_name] == "Fill" then
         color = ColorHexToInt("#71BEF1")|0x1000000
         --duration = 1
         part = "Verse Fill"
       end
       if line[col_color] == "Aending" and (line[col_name] == "ending" or line[col_name] == "Ending") then
         color = ColorHexToInt("#97D0FE")|0x1000000
         --duration = 2
         part = "Verse Ending"
       end
       if line[col_color] == "0" and (line[col_name] == "ending" or line[col_name] == "Ending") then -- any ending color
         color = ColorHexToInt("#42F4D1")|0x1000000
         --duration = 2
         part = "Any Ending"
       end
       if (line[col_color] == "B" or line[col_color] == "b") and line[col_name] == "PostFill" then
         color = ColorHexToInt("#0B7427")|0x1000000
         --duration = 1
         part = "Chorus PostFill"
       end
       if (line[col_color] == "B" or line[col_color] == "b") and line[col_name] == "Normal" then
         color = ColorHexToInt("#11AE3B")|0x1000000
         --duration = 1
         part = "Chorus"
       end
       if (line[col_color] == "B" or line[col_color] == "b") and line[col_name] == "Fill" then
         color = ColorHexToInt("#50ED7B")|0x1000000
         --duration = 1
         part = "Chorus Fill"
       end
       if line[col_color] == "Bending"  and (line[col_name] == "ending" or line[col_name] == "Ending") then
         color = ColorHexToInt("#9EF5B6")|0x1000000
         --duration = 2
         part = "Chorus Ending"
       end
 
       --hold_color = 29343679 ---------------------BF BF BF R 127 G 127 B 127 #7F7F7F
       --shot_color = 25132927 ---------------------7F 7F 7F R 191 G 191 B 191 #BFBFBF
 
       -- Shots Holds
 
       if line[col_name] == "0" then
         color = ColorHexToInt("#7F7F7F")|0x1000000 -- Hold
         part = "Hold"
       end
       if line[col_name] == "1" then
         color = ColorHexToInt("#BFBFBF")|0x1000000 -- Shot
         part = "Shot"
       end
 
       
 --(1)pattern,(2)type,(3)A verse B chorus,(4)weight,(5)mask,(6)duration,(7)bar
 --(1)shot,(2)0 shot 1 hold,(3)bar,(4)ticks,(5)duration ticks,weight,volume
 
 --col_pos = 7 -- Position column index in the CSV
 --col_pos_end = 4 -- Length column index in the CS
 --col_len = 6 -- Length column index in the CSV
 --col_name = 2 -- Name column index in the CSV
 --col_color = 3
 --col_pattern = 1
 --col_ticks = 5
 
 
 
 
          --retval, isrgn, rgnpos, rgnend, name, markrgnindexnumber, rgncolor = reaper.EnumProjectMarkers3(0, region_number)
          current_cursor_pos1 = reaper.GetCursorPosition()
 
          timesig_num, timesig_denom, bpm = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos1)
 
          --convert bar location and length from bars to time
          pos2 = ((((pos+1) * beat_per_measure)/ bb_bpm) * 60)
          len2 = ((((len) * beat_per_measure)/ bpm) * 60)
          bars_2 = ((((2) * beat_per_measure)/ bpm) * 60)
          region_length = (rgnend-rgnpos)
       
          --shot_bar1 = string.gsub(shot_bar, "A", "0")
          --shot_bar2 = string.gsub(shot_bar1, "B", "0")
 
          --if shot_bar == string.match(shot_bar, "%d") then
             --shot_bar2 = shot_bar
          --else shot_bar = "1" end
 
          duration2 = (dura_ticks / (bpm *2.5)) -- bpm *2 bb_bpm ??
          --Msg("shot_bar_pos ".. shot_bar2)
 
          if line[col_name] == "0" then
             --Msg("Hold > ".. shot_bar)
          end
 
          if line[col_name] == "1" then
             --Msg("Shot > ".. shot_bar)
          end
 
 
          --This needs to match only digits in the column 3 col_shot to give shot bar pos
 
          if line[col_name] == "0" or line[col_name] == "1" then
             shot_bar1 = line[col_shot]
             shot_bar_pos = ((((shot_bar1+1) * beat_per_measure)/ bb_bpm) * 60)
 
             --shot_bar_pos = (shot_bar / (bb_bpm *2))
             ticks_pos = (ticks / (bb_bpm *2))
             bar_pos_start = shot_bar_pos + ticks_pos
          end
 
          --Msg("Shot Bar ".. shot_bar_pos)
          --Shot region reaper.AddProjectMarker2( 0, true, bar_pos_start, bar_pos_start + duration2, "" , -1, color )
 --[[
          --Skip Shot/Hold region (this is done in drum_shot()
          if rgncolor == ColorHexToInt("#BFBFBF")|0x1000000 then region_number = region_number +1 goto enum_regions end -- Hold
          if rgncolor == ColorHexToInt("#7F7F7F")|0x1000000 then region_number = region_number +1 goto enum_regions end -- Shot
          --if color == ColorHexToInt("#97D0FE")|0x1000000 and region_length > bars_2 then region_length = bars_2 goto skip_ending
          --if color == ColorHexToInt("#9EFEB6")|0x1000000 and region_length > bars_2 then region_length = bars_2 goto skip_ending
 --]]
          --Fit 2 bar Ending to larger bars
          if rgncolor == ColorHexToInt("#97D0FE")|0x1000000 and region_length > bars_2 then region_length = bars_2 end
          if rgncolor == ColorHexToInt("#9EF5B6")|0x1000000 and region_length > bars_2 then region_length = bars_2 end
 
          --Fit Vesre/Chorus Ending to Any Ending
          if color == ColorHexToInt("#42F4D1")|0x1000000 and rgncolor == ColorHexToInt("#97D0FE")|0x1000000
             then rgncolor = ColorHexToInt("#42F4D1")|0x1000000 region_length = bars_2 end
          if color == ColorHexToInt("#42F4D1")|0x1000000 and rgncolor == ColorHexToInt("#9EF5B6")|0x1000000
             then rgncolor = ColorHexToInt("#42F4D1")|0x1000000 region_length = bars_2 end
          -- ADD ANY ENDING then rgncolor =
 
 
          --Fit any lenght Shot/Hold to any legnth region
          if rgncolor == ColorHexToInt("#BFBFBF")|0x1000000 and color == ColorHexToInt("#BFBFBF")|0x1000000 and region_length > duration2
             then region_length = duration2 shot_type = shot end -- shot
          if rgncolor == ColorHexToInt("#7F7F7F")|0x1000000 and color == ColorHexToInt("#7F7F7F")|0x1000000 and region_length > duration2
             then region_length = duration2 shot_type = shot end --hols
 
          if rgncolor == ColorHexToInt("#BFBFBF")|0x1000000 and color == ColorHexToInt("#BFBFBF")|0x1000000 and duration2 > region_length
             then region_length = region_length shot_type = shot end --shot
          if rgncolor == ColorHexToInt("#7F7F7F")|0x1000000 and color == ColorHexToInt("#7F7F7F")|0x1000000 and duration2 > region_length
             then region_length = region_length shot_type = shot end --hold
 --[[
          if rgncolor == ColorHexToInt("#BFBFBF")|0x1000000 and color == ColorHexToInt("#BFBFBF")|0x1000000 and duration2 > region_length
             then duration2 = region_length shot_type = shot end --shot
          if rgncolor == ColorHexToInt("#7F7F7F")|0x1000000 and color == ColorHexToInt("#7F7F7F")|0x1000000 and duration2 > region_length
             then duration2 = region_length shot_type = shot end --hold
 --]]
       --Msg("".. part .."bars ".. len .." Time ".. len2)
       --Msg("Reg ".. region_length)
       --Msg("Drum ".. color .." Reg Color ".. rgncolor)
 
       --var random_boolean = Math.random() < 0.7;
       --// 70% this will be true, 30% false+
       --math.random(0, 1) == 1 and
       --math.random()
 
       pass = (math.random( 0, 4 ) )
       --Msg("Pass ".. pass)
       --pass = pass + 1
       
 
             
       if color == ColorHexToInt("#FF80C0")|0x1000000 and rgncolor == ColorHexToInt("#FF80C0")|0x1000000 then pass = 1 end -- Count-in
       if color == ColorHexToInt("#97D0FE")|0x1000000 and rgncolor == ColorHexToInt("#97D0FE")|0x1000000 then pass = 1 end -- Verse Ending
       if color == ColorHexToInt("#9EF5B6")|0x1000000 and rgncolor == ColorHexToInt("#9EF5B6")|0x1000000 then pass = 1 end -- Chorus Ending
 
 --[[
           for 1=0, tempo_marker_count -1 do
           retval, timepos, measurepos, beatpos, bpm, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker(0, i)
               if measurepos == rgnpos
               if measurepos > rgnpos and measurepos <= regend
 --]]
 
 
 
       --Msg("region_length ".. region_length .." Drum Length ".. len2 .." part".. part)
    
 
       if pass == 1 and color == rgncolor and len2 >= (region_length -.011) then
        match = match +1
       --Msg("Matched ")
       --Msg("Drum Color ".. color .." Region Color ".. rgncolor .. " ".. part .." pos ".. pos .." " .." \n ==============")
       
          --if color == ColorHexToInt("#97D0FE")|0x1000000 and item_length > bars_2 then item_length = bars_2 end
          --if color == ColorHexToInt("#9EFEB6")|0x1000000 and item_length > bars_2 then item_length = bars_2 end
 
          --get_tempo_markers()
          
          
 
          current_cursor_pos = reaper.GetCursorPosition()
          
          --if current_cursor_pos == pre_cursor_pos then region_number = region_number +1 goto enum_regions end
          
          -- pre_cursor_pos = current_cursor_pos
 
          timesig_num, timesig_denom, tempo = reaper.TimeMap_GetTimeSigAtTime(0, current_cursor_pos)
 
          --Msg("current_cursor_pos ".. current_cursor_pos)
          --if start_time ~= end_time and current_cursor_pos == end_time then goto finish end
 
          
 
          reaper.Main_OnCommand(40058, 0)  -- Item: Paste items/tracks
 
          reaper.Main_OnCommand(41173, 0) -- Item navigation: Move cursor to start of items
          
          
          --Msg("Pasted @ ".. region_number .." > ".. current_cursor_pos)
          
          imported_drums = reaper.GetSelectedMediaItem(0, 0)
          take = reaper.GetActiveTake( imported_drums )
          --(Reaper centi-beats 1 beat = 100) (Biab 1 beat = 120 ticks)
 
          --playrate2 = (tempo / bb_bpm)
 
          --reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", playrate2 )
 
          --Convert - to + and + to - offset
          --C = rd_offset
          --D = 0 - C
 
          --Msg("Offset= ".. rd_offset)
          rd_offset1 = 0 - rd_offset
 
          user_offset1 = 0 - user_offset
 
          --user_offset = (user_offset / (bb_bpm *2))
          rd_offset2 =(rd_offset1 / 4000)
          --Msg("RD Offset Ticks ".. rd_offset)
          --Msg("RD Offset Time ".. rd_offset2)
          user_offset2 = (user_offset1 / 1000)
          --Msg("User Offset Time "..user_offset2)
          -- wam media_offset = .092 80bpm .12  .074 100bpm .12
          -- mp4 media_offset = .050 80bpm .065 .039 100bpm .065
 
 
          --pos2 = ((((pos+1) * beat_per_measure)/ bb_bpm) * 60)
 
          --the compressed media has a bit of delay at the start of the file
          --if realdrums_extension == ".wma" then media_offset = ((2 / bb_bpm) * 10) end  -- .12
          if realdrums_extension == ".wma" then media_offset = .047 end --((3.9 / bpm) * 5 ) end --  (lower more delay   / bpm) * x lower more delay
          if realdrums_extension == ".m4a" then media_offset = 0 end --((.064 / bpm) * 45) end
          if realdrums_extension == ".mp4" then media_offset = .047 end -- = ((.064 / bpm) * 45) end
          if realdrums_extension == ".wav" then media_offset = 0 end
          if realdrums_extension == ".aif" then media_offset = 0 end
 
          --this is used in reaper.SetMediaItemTakeInfo_Value for start pos2 + offset
          --(using only media_offset at the moment)
          offset1 = (user_offset2 + media_offset + rd_offset2)
          
          --region_length = (rgnend-rgnpos)
          
          --Msg("region_number ".. region_number)
          --Msg("color ".. color)
          --Msg("region_length ".. region_length)
 
          --get_tempo_markers()
 
          if line[col_pattern] == "Shot" then
 
             playrate = (tempo / bb_bpm)
 
             reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", playrate2 )
 
             reaper.SetMediaItemTakeInfo_Value( take, "D_STARTOFFS", bar_pos_start + offset1 )
 
             reaper.SetMediaItemLength(imported_drums, region_length, 0)
 
             reaper.SetMediaItemTakeInfo_Value( take, "I_CUSTOMCOLOR", color )
          end
 
          if line[col_pattern] == "pattern" then
          
             --Msg("color".. color)
            -- Msg("region_length ".. region_length)
 
             playrate2 = (tempo / bb_bpm)
 
             reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", playrate2 )
 
             reaper.SetMediaItemTakeInfo_Value( take, "D_STARTOFFS", pos2 + offset1 )
 
             reaper.SetMediaItemLength(imported_drums, region_length, 0)
 
             reaper.SetMediaItemTakeInfo_Value( take, "I_CUSTOMCOLOR", color )
 
 
          end
 
          if consecutive == 1 then
             reaper.SetEditCurPos(iPosOut, 0, 0)
 
             --commandID7 = reaper.NamedCommandLookup("_RSa269108c0ba744d947b179c93a57c34399b55a43")
             --reaper.Main_OnCommand(commandID7, 0) -- Script: ReaTrak Go to start of previous region.lua
             goto_previous_region()
 
             --reaper.Main_OnCommand(41801, 0) -- Regions: Go to previous region after current region finishes playing (smooth seek)
 
          end
 
 
          --commandID3 = reaper.NamedCommandLookup("_RSce47da3c9b1238de71cc94a1cb99732b9abd5e41")
          --reaper.Main_OnCommand(commandID3, 0) -- Script: ReaTrak Go to start of next region.lua
          goto_next_region()
 
            --reaper.GoToRegion(0, region_number +1, true)
 
         if region_number < num_regionsOut then
            loop_stuck = loop_stuck + 1
            --Msg("goto enu 2nd last")
            --Msg("region_number ".. region_number)           
            region_number = region_number +1
            goto enum_regions end
         if region_number -1 == num_regionsOut  then goto finish  -- num_regionsOut
 
         --if region_number < num_regionsOut then
 
            --drum_pattern()
         --region_number = region_number +1
 
 
 
 
 
         end
 
 
       end
 
       --end
       --if region_number >= num_regionsOut then  goto finish end -- num_regionsOut
       --if region_number < num_regionsOut then goto start_match end
       end
 
 
         --if region_number > region_count then goto finish end
         --Bars to time
         --pos2 = ((((pos) * beat_per_measure)/ bpm) * 60)
         --len2 = (((len * beat_per_measure)/ bpm) * 60)
 
         --reaper.AddProjectMarker2( 0, true, pos2,pos2 + len2, "", -1, color )
      end
 
     end
 
        if region_number < num_regionsOut  then
           loop_stuck = loop_stuck + 1
           --region_number = region_number + 1
           --Msg("goto enu last")
           --Msg("region_number ".. region_number)
           --Msg("enu last region_number ".. region_number)
           region_number = previous_region
           _, _, pos_previous, _, _, _, _ = reaper.EnumProjectMarkers3(0, region_number)
           reaper.SetEditCurPos(pos_previous, 1, 0)
           goto enum_regions end
       --if region_number >= num_regionsOut then  goto finish end -- num_regionsOut
   --Msg("Due to > (2nd bottom) ")
   goto finish
   --end
 ::finish::
 --Msg("Finish Region ".. region_number .." of ".. region_count)
 --if region_number < num_regionsOut -1  then loop_stuck = loop_stuck + 1 goto enum_regions end
 --Msg("Final Finish")
 end
 
 
 
 
 
 
 
 -- INIT
 goto choose
 ::choose::
 --if current_drum == 0 then
   --retval, filetxt = reaper.GetUserFileNameForRead("", "Import Biab Drum Style txt", "txt")
 
 --filetxt = drum_path_files3[listbox_val2]--:gsub("\\", "\\\\")
 filetxt = drum_path_files3[listbox_val2]
 folder = filetxt:match[[^@?(.*[\/])[^\/]-$]]
 
 --filetxt = folder..GetFilename(filetxt)
 

 --txt_filename2 = filetxt:gsub[[^@?(.*[\/])[^\/]-$]]
 --Msg("Folder "..folder)
 --Msg("Filename "..txt_filename2)
 --[[
 os_type = reaper.GetOS() -- "Mac OSX" -- "Win64" --
 --slash = string.match(os_type, "Win") and "\\" or "/"
 
 if os_type ~= "Win32" and os_type ~= "Win64" then
 --Mac OS
    dir1 = string.gsub(filetxt, "/[^/]*$", "")
    dir = directory1 .."/"
    txt_filename1 = string.match(filetxt, "/[^/]*$")
    txt_filename = string.gsub(txt_filename, "/", "")
    txt_filename_folder = string.gsub(wavename2, "_.*", "") -- remove _ and text after it
    blank_ext = string.gsub(txt_filename, ".txt", "")
    dir_back1 = string.gsub(dir1,"(.*)/.*$","%1")
    dir_back2 = string.gsub(dir_back1,"(.*)/.*$","%1")
    dir_back = dir_back1 .."/"
    txt_filename_folder = txt_filename_folder2 .."/"
 
    --Needs root drum name from txt wavname=*****
 else
 --Win OS
    dir1 = string.gsub(filetxt, "\\[^\\]*$", "")
    dir = dir1 .."\\"
    txt_filename1 = string.match(filetxt, "\\[^\\]*$")
    txt_filename = string.gsub(txt_filename1, "\\", "")
    txt_filename_folder = string.gsub(wavename2, "_.*", "") -- remove _ and text after it
    blank_ext = string.gsub(txt_filename, ".txt", "")
    dir_back1 = string.gsub(dir1,"(.*)\\.*$","%1")
    dir_back2 = string.gsub(dir_back1,"(.*)\\.*$","%1")
    dir_back = dir_back1 .."\\"
    txt_filename_folder2 = txt_filename_folder .."\\"
 
    --open_file = dir .. "ModCountry16ths^_080_Style.wav" --blank_ext .. realdrums_extension
    --open_file_back = dir_back .. wavename --dir1_back .. blank_ext .. realdrums_extension
 
    --use in function to check dir ot dir_back
     --check_path = reaper.file_exists(open_file)
 
     --check_path = reaper.file_exists(open_file_back)
 
 end
 --]]
 --slash = "/" --string.match(os_type, "Win") and "\\" or "/"
 
 --Msg("Folder ".. directory)
 --Msg("Filename1 ".. txt_filename1)
 --Msg("Filename ".. txt_filename)
 
 --GetFiles(path)
 --GetPathSeparator()
 --filename_table()
 
 if filetxt then -- retval then
 
   reaper.PreventUIRefresh(1)
 
   reaper.Undo_BeginBlock() -- Begining of the undo block. Leave it at the top of your main function.
 
   --reaper.ClearConsole()
 
   --read_lines_details(filetxt)
 
   read_lines(filetxt) --Msg ("goto read_lines "..filetxt)
 
   drum_pattern()
 
   if regions_saved == 1 then
       --commandID1 = reaper.NamedCommandLookup("_RS1c82e587d259e8ea79f40a64b7a92feb8450e477")
       --reaper.Main_OnCommand(commandID1, 0) -- Script: ReaTrak Import regions from file.lua
       import_regions()
   end
 
   extend_post_fills()
   
   reaper.SetEditCurPos(org_cur_pos, 1, 0)
      
   
   --GetStems()
 
   --last_action = reaper.Undo_CanUndo2(0) Msg("Last Action ".. last_action)
 
   reaper.Undo_EndBlock("ReaTrak fit biab drums to regions", -1) -- End of the undo block. Leave it at the bottom of your main function.
 
   reaper.UpdateArrange()
 
   reaper.PreventUIRefresh(-1)
 
 end
 
::finish2:: 


end

------------------------------------
-------- Window settings -----------
------------------------------------


GUI.name = "Biab Drums"
GUI.x, GUI.y, GUI.w, GUI.h = 0, 0, 500, 440
GUI.anchor, GUI.corner = "mouse", "C"




------------------------------------
-------- GUI Elements --------------
------------------------------------


--[[     

  Button          z,      x,      y,      w,      h, caption, func[, ...]
  Checklist     z,      x,      y,      w,      h, caption, opts[, dir, pad]
  Menubox          z,      x,      y,      w,      h, caption, opts, pad, noarrow]
  Slider          z,      x,      y,      w,      caption, min, max, defaults[, inc, dir]
  
]]--

--GUI.New("mnu_mode",     "Menubox",          1, 64,     32,  72, 20, "Mode:", "Auto,Punch,Step")
--GUI.New("chk_opts",     "Checklist",     1, 192,     32,  192, 96, "Options", "Only in time selection,Only on selected track,Glue items when finished", "v", 4)
--GUI.New("sldr_thresh", "Slider",     1, 32,  96, 128, "Threshold", -60, 0, 48, nil, "h")
--GUI.New("btn_go",     "Button",          1, 168, 152, 64, 24, "Go!", btn_click)

x1=20


GUI.New("region_number_btn",      "Button",           3, 110, 10+x1, 170, 20, "Show/Hide Region Numbers", btn_click_region_number)
GUI.elms.region_number_btn.col_txt = "black"
GUI.elms.region_number_btn.col_fill = "bridge"

GUI.New("new_region_btn",      "Button",           3, 10, 40+x1, 125, 20, "New Region at Cursor", btn_click_new_region)
GUI.elms.new_region_btn.col_txt = "yellow"
GUI.elms.new_region_btn.col_fill = "shot"

GUI.New("edit_chord2_btn",      "Button",           3, 145, 40+x1, 110, 20, "Edit Name/Chord", btn_click_edit_chord)
GUI.elms.edit_chord2_btn.col_txt = "yellow"
GUI.elms.edit_chord2_btn.col_fill = "shot"

GUI.New("chord_split_btn",      "Button",           3, 265, 40+x1, 125, 20, "Split Region at Cursor", btn_click_chord_split)
GUI.elms.chord_split_btn.col_txt = "yellow"
GUI.elms.chord_split_btn.col_fill = "shot"

GUI.New("chord_pre_btn",      "Button",           3, 80, 80+x1, 115, 20, "< Previous Region", btn_click_chord_pre)
GUI.elms.chord_pre_btn.col_txt = "yellow"
GUI.elms.chord_pre_btn.col_fill = "shot"

GUI.New("chord_next_btn",      "Button",           3, 200, 80+x1, 95, 20, "Next Region >", btn_click_chord_next)
GUI.elms.chord_next_btn.col_txt = "yellow"
GUI.elms.chord_next_btn.col_fill = "shot"

GUI.New("bar_pre_btn",      "Button",           3, 60, 120+x1, 50, 20, "< Bar", btn_click_bar_pre)
GUI.elms.bar_pre_btn.col_txt = "yellow"
GUI.elms.bar_pre_btn.col_fill = "shot"

GUI.New("bar_next_btn",      "Button",          3, 260, 120+x1, 50, 20, "Bar >", btn_click_bar_next)
GUI.elms.bar_next_btn.col_txt = "yellow"
GUI.elms.bar_next_btn.col_fill = "shot"

GUI.New("beat_pre_btn",      "Button",           3, 130, 120+x1, 45, 20, "< Beat", btn_click_beat_pre)
GUI.elms.beat_pre_btn.col_txt = "yellow"
GUI.elms.beat_pre_btn.col_fill = "shot"

GUI.New("beat_next_btn",      "Button",           3, 195, 120+x1, 45, 20, "Beat >", btn_click_beat_next)
GUI.elms.beat_next_btn.col_txt = "yellow"
GUI.elms.beat_next_btn.col_fill = "shot"

GUI.New("my_chord",   "Textbox",     3, 140, 150+x1, 140, 20, "", 4)

GUI.New("btn_chord",     "Button",          3, 10, 150+x1, 120, 20, "Insert Name/Chord >", btn_click_chord)

GUI.New("verse_post_fill_btn",      "Button",           3, 10, 200+x1, 95, 20, "Verse Post Fill", btn_click_verse_post_fill)
GUI.elms.verse_post_fill_btn.col_txt = "btn_txt1"
GUI.elms.verse_post_fill_btn.col_fill = "verse_post_fill" 

GUI.New("verse_btn",      "Button",           3, 110, 200+x1, 65, 20, "Verse", btn_click_verse)
GUI.elms.verse_btn.col_txt = "btn_txt1"
GUI.elms.verse_btn.col_fill = "verse"

GUI.New("verse_fill_btn",      "Button",           3, 180, 200+x1, 95, 20, "Verse Fill", btn_click_verse_fill)
GUI.elms.verse_fill_btn.col_txt = "btn_txt3"
GUI.elms.verse_fill_btn.col_fill = "verse_fill"

GUI.New("verse_ending_btn",      "Button",           3, 280, 200+x1, 90, 20, "Verse Ending ", btn_click_verse_ending)
GUI.elms.verse_ending_btn.col_txt = "btn_txt3"
GUI.elms.verse_ending_btn.col_fill = "verse_ending"

GUI.New("chorus_post_fill_btn",      "Button",           3, 10, 230+x1, 95, 20, "Chorus Post Fill", btn_click_chorus_post_fill)
GUI.elms.chorus_post_fill_btn.col_txt = "btn_txt1"
GUI.elms.chorus_post_fill_btn.col_fill = "chorus_post_fill"

GUI.New("chorus_btn",      "Button",           3, 110, 230+x1, 65, 20, "Chorus", btn_click_chorus)
GUI.elms.chorus_btn.col_txt = "btn_txt1"
GUI.elms.chorus_btn.col_fill = "chorus"

GUI.New("chorus_fill_btn",      "Button",           3, 180, 230+x1, 95, 20, "Chorus Fill", btn_click_chorus_fill)
GUI.elms.chorus_fill_btn.col_txt = "btn_txt3"
GUI.elms.chorus_fill_btn.col_fill = "chorus_fill"

GUI.New("chorus_ending_btn",      "Button",           3, 280, 230+x1, 90, 20, "Chorus Ending ", btn_click_chorus_ending)
GUI.elms.chorus_ending_btn.col_txt = "btn_txt3"
GUI.elms.chorus_ending_btn.col_fill = "chorus_ending"

GUI.New("count_in_btn",      "Button",           3, 140, 175+x1, 95, 20, "2 Bar Count-In", btn_click_count_in)
GUI.elms.count_in_btn.col_txt = "btn_txt3"
GUI.elms.count_in_btn.col_fill = "count_in" 

GUI.New("btn_create_file",     "Button",          4, 370, 60, 120, 54, "Create Drum Track", btn_click_create_file)

GUI.New("btn_create_stems",     "Button",          4, 370, 120, 120, 54, "    Create Stems".."\n".."    from selected".."\n".."Stereo Drum track", btn_click_create_stems)

GUI.New("btn_create_midi",     "Button",          4, 370, 180, 120, 54, "Create MIDI Track".."\n".."    from selected".."\n".."Stereo Drum track", btn_click_create_midi)

GUI.New("solo_demo_btn",      "Button",           4, 370, 240, 120, 20, "Play Solo Demo", btn_click_solo_demo)
GUI.elms.solo_demo_btn.col_txt = "btn_txt3"
GUI.elms.solo_demo_btn.col_fill = "chorus"

GUI.New("band_demo_btn",      "Button",           4, 370, 270, 120, 20, "Play Band Demo", btn_click_band_demo)
GUI.elms.band_demo_btn.col_txt = "btn_txt3"
GUI.elms.band_demo_btn.col_fill = "bridge"

GUI.New("stop_demo_btn",      "Button",           4, 370, 300, 120, 20, "Stop Demo", btn_click_stop_demo)
GUI.elms.stop_demo_btn.col_txt = "btn_txt1"
GUI.elms.stop_demo_btn.col_fill = "darkred"

--GUI.New("lb_Sect",      "Label",           3, 100, 280, "ReaTrak Sections", true, 1)

GUI.New("my_frm",      "Frame",           3,20, 310, 340, 85, true, true, "elm_bg", 4)
GUI.elms.my_frm.text = "*Time selection will do just that section, use to build up".."\n".."*Select a Biab Drum Style txt file in \\bb\\Drums".."\n".."*Create a 2 bar count-in".."\n".."*Fills are 1 bar".."\n".."*If you have drum stems they will be add to extra tracks"
GUI.elms.my_frm.col_txt = "white"


--GUI.New("file_list", "Listbox",  5,  15,  40,  300, 308, drum_path_files2, false, "")

GUI.New("file_list2", "Listbox",  4,  15,  40,  350, 308, drum_path_files2, false, "")

GUI.New("browse_btn",      "Button",           4, 10, 350, 105, 20, "Browse Path", browse_folder) 
GUI.elms.browse_btn.col_txt = "yellow"
GUI.elms.browse_btn.col_fill = "shot"

GUI.New("search_btn",      "Button",           4, 150, 350, 105, 20, "Search", search_folder) 
GUI.elms.search_btn.col_txt = "yellow"
GUI.elms.search_btn.col_fill = "shot"

GUI.New("my_search",   "Textbox",     4, 270, 350, 180, 20, "", 4)

--GUI.New("selected_drum_btn",      "Button",           4, 10, 30, 105, 20, "Use Selected Drum", selected_drum) 
--GUI.elms.selected_drum_btn.col_txt = "yellow"
--GUI.elms.selected_drum_btn.col_fill = "shot"

GUI.New("my_frm6",      "Frame",           4, 10, 380, 480, 35, true, true, "elm_bg", 4)
GUI.elms.my_frm6.text = "drumfile_path2"
GUI.elms.my_frm6.col_txt = "white"

function GUI.elms.my_search:lostfocus() -- get Enter key thanks to solger https://forum.cockos.com/member.php?u=56856
  search_folder()
  GUI.Textbox.lostfocus(self)
end

btn_click_refresh()

GUI.Init()
GUI.Main()

